// Load dts shapes and merge animations
datablock TSShapeConstructor(BugDts)
{
	baseShape  = "./bug3.dts";
	sequence0  = "./bug_root.dsq root";

	sequence1  = "./bug_run.dsq run";
	sequence2  = "./bug_run.dsq walk";
	sequence3  = "./bug_back.dsq back";
	sequence4  = "./bug_side.dsq side";

	sequence5  = "./bug_root.dsq crouch";
	sequence6  = "./bug_run.dsq crouchRun";
	sequence7  = "./bug_back.dsq crouchBack";
	sequence8  = "./bug_side.dsq crouchSide";

	sequence9  = "./bug_look.dsq look";
	sequence10 = "./bug_root.dsq headside";
	sequence11 = "./bug_root.dsq headUp";

	sequence12 = "./bug_jump.dsq jump";
	sequence13 = "./bug_jumpstand.dsq standjump";
	sequence14 = "./bug_fall.dsq fall";
	sequence15 = "./bug_land.dsq land";

	sequence16 = "./bug_attack.dsq armAttack";
	sequence17 = "./bug_root.dsq armReadyLeft";
	sequence18 = "./bug_root.dsq armReadyRight";
	sequence19 = "./bug_root.dsq armReadyBoth";
	sequence20 = "./bug_root.dsq spearready";  
	sequence21 = "./bug_root.dsq spearThrow";

	sequence22 = "./bug_talk.dsq talk";  

	sequence23 = "./bug_death1.dsq death1"; 
	
	sequence24 = "./bug_root.dsq shiftUp";
	sequence25 = "./bug_root.dsq shiftDown";
	sequence26 = "./bug_root.dsq shiftAway";
	sequence27 = "./bug_root.dsq shiftTo";
	sequence28 = "./bug_root.dsq shiftLeft";
	sequence29 = "./bug_root.dsq shiftRight";
	sequence30 = "./bug_root.dsq rotCW";
	sequence31 = "./bug_root.dsq rotCCW";

	sequence32 = "./bug_root.dsq undo";
	sequence33 = "./bug_root.dsq plant";

	sequence34 = "./bug_death1.dsq sit";

	sequence35 = "./bug_root.dsq wrench";

   sequence36 = "./bug_attack.dsq activate";
   sequence37 = "./bug_attack.dsq activate2";

   sequence38 = "./bug_root.dsq leftrecoil";
};    

datablock AudioProfile(BugPainSound)
{
   fileName = "./bug_pain.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(BugDeathSound)
{
   fileName = "./bug_death.wav";
   description = AudioClose3d;
   preload = true;
};
datablock fxDTSBrickData (BrickBugBot_HoleSpawnData)
{
	brickFile = "Add-ons/Bot_Hole/4xSpawn.blb";
	category = "Special";
	subCategory = "Holes";
	uiName = "Bug Hole";
	iconName = "Add-Ons/Bot_Blockhead/icon_blockhead";

	bricktype = 2;
	cancover = 0;
	orientationfix = 1;
	indestructable = 1;

	isBotHole = 1;
	holeBot = "BugHoleBot";
};

datablock PlayerData(BugHoleBot : PlayerStandardArmor)
{
//	category = Armor;
	shapeFile = "./bug3.dts";

	cameraMaxDist = 4;
	cameraTilt = 0.1;//0.174 * 2.5; //~25 degrees
	cameraVerticalOffset = 1;
//	computeCRC = false;
	
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 10;		//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;

	maxDamage = 15;
	runforce = 50 * 90;
	maxForwardSpeed = 4.2;	//4.5
	maxBackwardSpeed = 3.2;	//4.5
	maxSideSpeed = 2;
	jumpsound = "";
	maxForwardCrouchSpeed = 2;
	maxBackwardCrouchSpeed = 1;
	maxSideCrouchSpeed = 1;
	
    boundingBox				= vectorScale("0.8 0.8 0.5", 4); //"2.5 2.5 2.4";
    crouchBoundingBox		= vectorScale("0.8 0.8 0.5", 4); //"2.5 2.5 2.4";
    proneBoundingBox		= vectorScale("0.8 0.8 0.5", 4); //"2.5 2.5 2.4";
	
	mass = 50;

	jumpForce = 4.5 * 90; //4 * 90;
    jumpDelay = 0.2;

	maxStepHeight = 0.4;

	minImpactSpeed = 25;	//20
	speedDamageScale = 3;	//4.3

	useCustomPainEffects = true;
	PainHighImage = "PainLowImage";
	PainMidImage  = "PainLowImage";
	PainLowImage  = "PainLowImage";
	PainSound			= BugPainSound;
	DeathSound			= BugDeathSound;

	uiName = "B1 Bug";
	rideable = false;
	canRide = false;
//	numMountPoints = 0;
	paintable = true;
	skinColor = "0.220 0.404 0.188 1"; //Default Color

	isSmallEnemy = 1;

	//Hole Attributes

	isHoleBot = 1;

	//Spawning option
	hSpawnTooClose = 0;//Doesn't spawn when player is too close and can see it
	  hSpawnTCRange = 8;//above range, set in brick units
	hSpawnClose = 0;//Only spawn when close to a player, can be used with above function as long as hSCRange is higher than hSpawnTCRange
	  hSpawnCRange = 32;//above range, set in brick units

	hType = Bug; //Enemy,Friendly, Neutral
	  hNeutralAttackChance = 100; //0 to 100, Chance that this type will attack neutral bots, ie horses/vehicles/civilians
	//can have unique types, nazis will attack zombies but nazis will not attack other bots labeled nazi
	hName = "Bug";//cannot contain spaces
	hTickRate = 3000;
	
	//Wander Options
	hWander = 1;//Enables random walking
	  hSmoothWander = 1;//This is in addition to regular wander, makes them walk a bit longer, and a bit smoother
	  hReturnToSpawn = 1;//Returns to spawn when too far
	  hSpawnDist = 48;//Defines the distance bot can travel away from spawnbrick
	  hGridWander = 0;//Locks the bot to a grid, overwrites other settings
	
	//Searching options
	hSearch = 1;//Search for Players
	  hSearchRadius = 64;//in brick units
	  hSight = 1;//Require bot to see player before pursuing
	  hStrafe = 1;//Randomly strafe while following player
	hSearchFOV = 0;//if enabled disables normal hSearch
	  hFOVRange = 0.7; // determines the angle we can see the player at, 0.7 is about normal fov for players, if 0 we can see all in front, if 1 we could only see someone perfectly ahead, can be negative
	  // hFOVRadius = 6; // no longer used, we now use searchRadius
	  hHearing = 1;//If it hears a player it'll look in the direction of the sound

	  hAlertOtherBots = 1;//Alerts other bots when he sees a player, or gets attacked

	//Attack Options
	hMelee = 0;//Melee
	  hAttackDamage = 17;//Melee Damage
	hShoot = 1;
	  hWep = "BugBiteItem";
	  hShootTimes = 4;//Number of times the bot will shoot between each tick
	  hMaxShootRange = 32;//The range in which the bot will shoot the player	//64
	  hAvoidCloseRange = 0;//
		hTooCloseRange = 7;//in brick units

	//Misc options
	hActivateDirection = 0; // 0 1 2, determines the direction you have to face the bot to activate him, both, front back
	hMoveSlowdown = 0; // bool, determines wether the bot will slow down when following enemies
	hAvoidObstacles = 1;
	hSuperStacker = 1;//When enabled makes the bots stack a bit better, in other words, jumping on each others heads to get to a player
	hSpazJump = 1;//Makes bot jump when the user their following is higher than them

	hAFKOmeter = 1;//Determines how often the bot will wander or do other idle actions, higher it is the less often he does things

	hIdle = 1;// Enables use of idle actions, actions which are done when the bot is not doing anything else
	  hIdleAnimation = 0;//Plays random animations/emotes, sit, click, love/hate/etc
	  hIdleLookAtOthers = 1;//Randomly looks at other players/bots when not doing anything else
	    hIdleSpam = 0;//Makes them spam click and spam hammer/spraycan
	  hSpasticLook = 1;//Makes them look around their environment a bit more.
	hEmote = 0;


	//Old Zombie mod code

//	attackpower = 17;
//	BrickDestroyMaxVolume = 150;
//	BrickMaxJumpHeight = 0;
//	BrickKillRadius = 2;
//	FollowAnim = "ArmReadyBoth";
//	ZombieTeam = "Bugs";
//	NoBloodyHands = 1;
//	DoNotZombify = 1;
//	chance = 95;
//	SearchRadius = 10;
//	SpecialAttack = 0;
//	zDeathSound = "BugDeathSound";
//	ignorePipeBombs = 0;

};
//function BugHoleBot::ondisabled(%this,%obj)
//{
//	parent::ondisabled(%this,%obj);
//	ZombieDefault::ondisabled(%this,%obj);
//}
//function BugHoleBot::onCollision(%this, %obj, %col, %fade, %pos, %norm)
//{
//	parent::oncollision(%this, %obj, %col, %fade, %pos, %norm);
//	ZombieDefault::onCollision(%this, %obj, %col, %fade, %pos, %norm);
//	if(IsInMinigame(%obj) && IsInSameMinigame(%col,%obj) && %obj.getstate() !$= "Dead" && %obj.spawnbrick.getgroup().client.minigame.EnableZombies == 1)
//	{
//		%col.applyimpulse(%col.getposition(),vectoradd(vectorscale(%obj.getforwardvector(),0),"0 0 0"));
//	}
//	if(IsInMinigame(%obj) && MinigameIncludesPlayerBricks(%col) && %col.iszombie && %obj.getstate() !$= "Dead")
//	{
//		%col.applyimpulse(%col.getposition(),vectoradd(vectorscale(%obj.getforwardvector(),0),"0 0 0"));
//		%obj.playthread(2,activate2);
//	}
//}
//function BugHoleBot::onMount(%a,%player,%vehicle,%d,%e,%f)
//{
//	ZombieDefault::onMount(%a,%player,%vehicle,%d,%e,%f);
//	parent::onMount(%a,%player,%vehicle,%d,%e,%f);
//}
//function BugHoleBot::onUnMount(%a,%player,%vehicle,%d,%e,%f)
//{
//	ZombieDefault::onUnMount(%a,%player,%vehicle,%d,%e,%f);
//	parent::onUnMount(%a,%player,%vehicle,%d,%e,%f);
//}
function BugHoleBot::onAdd(%this,%obj)
{
	armor::onAdd(%this,%obj);

//	parent::onAdd(%this,%obj);
//	ZombieDefault::onAdd(%this,%obj);
//	%obj.name = "Bug";

//	//call fixed recolor script
	schedule(15,0,recolorbug,%obj);	
}


