// Load dts shapes and merge animations
datablock TSShapeConstructor(SpiderDts)
{
	baseShape  = "./spider2.dts";
	sequence0  = "./spdr_root.dsq root";

	sequence1  = "./spdr_run.dsq run";
	sequence2  = "./spdr_run.dsq walk";
	sequence3  = "./spdr_back.dsq back";
	sequence4  = "./spdr_side.dsq side";

	sequence5  = "./spdr_crouch.dsq crouch";
	sequence6  = "./spdr_run.dsq crouchRun";
	sequence7  = "./spdr_back.dsq crouchBack";
	sequence8  = "./spdr_side.dsq crouchSide";

	sequence9  = "./spdr_root.dsq look";
	sequence10 = "./spdr_root.dsq headside";
	sequence11 = "./spdr_root.dsq headUp";

	sequence12 = "./spdr_jump.dsq jump";
	sequence13 = "./spdr_jump.dsq standjump";
	sequence14 = "./spdr_fall.dsq fall";
	sequence15 = "./spdr_root.dsq land";

	sequence16 = "./spdr_attack.dsq armAttack";
	sequence17 = "./spdr_root.dsq armReadyLeft";
	sequence18 = "./spdr_root.dsq armReadyRight";
	sequence19 = "./spdr_root.dsq armReadyBoth";
	sequence20 = "./spdr_root.dsq spearready";  
	sequence21 = "./spdr_root.dsq spearThrow";

	sequence22 = "./spdr_attack.dsq talk";  

	sequence23 = "./spdr_death.dsq death1"; 
	
	sequence24 = "./spdr_root.dsq shiftUp";
	sequence25 = "./spdr_root.dsq shiftDown";
	sequence26 = "./spdr_root.dsq shiftAway";
	sequence27 = "./spdr_root.dsq shiftTo";
	sequence28 = "./spdr_root.dsq shiftLeft";
	sequence29 = "./spdr_root.dsq shiftRight";
	sequence30 = "./spdr_root.dsq rotCW";
	sequence31 = "./spdr_root.dsq rotCCW";

	sequence32 = "./spdr_root.dsq undo";
	sequence33 = "./spdr_attack.dsq plant";

	sequence34 = "./spdr_crouch.dsq sit";

	sequence35 = "./spdr_attack.dsq wrench";

   sequence36 = "./spdr_attack.dsq activate";
   sequence37 = "./spdr_attack.dsq activate2";

   sequence38 = "./spdr_root.dsq leftrecoil";
};    
datablock AudioProfile(SpiderPainSound)
{
   fileName = "./spider_pain.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(SpiderDeathSound)
{
   fileName = "./spider_death.wav";
   description = AudioClose3d;
   preload = true;
};

datablock fxDTSBrickData (BrickSpiderBot_HoleSpawnData)
{
	brickFile = "Add-ons/Bot_Hole/4xSpawn.blb";
	category = "Special";
	subCategory = "Holes";
	uiName = "Spider Hole";
	iconName = "Add-Ons/Bot_Blockhead/icon_blockhead";

	bricktype = 2;
	cancover = 0;
	orientationfix = 1;
	indestructable = 1;

	isBotHole = 1;
	holeBot = "SpiderHoleBot";
};


datablock PlayerData(SpiderHoleBot : PlayerStandardArmor)
{
//	category = Armor;
	shapeFile = "./spider2.dts";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	mass = 120;	
//	drag = 0.3;

	maxItems   = 10;		//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;

	maxDamage = 220;
	runforce = 60 * 120;
	maxForwardSpeed = 14;
	maxBackwardSpeed = 10;
	maxSideSpeed = 8;
	jumpsound = "";
	
	maxForwardCrouchSpeed = 7;
	maxBackwardCrouchSpeed = 5;
	maxSideCrouchSpeed = 2;

	boundingBox				= vectorScale("1.8 1.8 1.5", 4); //"2.5 2.5 2.4";
	crouchBoundingBox		= vectorScale("1.8 1.8 1.1", 4); //"2.5 2.5 2.4";
	proneBoundingBox		= vectorScale("1.8 1.8 1.5", 4); //"2.5 2.5 2.4";

	jumpForce = 7.8 * 120; //7.5 * 120;
    jumpDelay = 0.1;	
    maxStepHeight = 1.4;	//1

//        minImpactSpeed = 160;
//        speedDamageScale = 4.8;

	uiName = "B1 Spider";
	rideable = false;
	canRide = false;
	paintable = true;
	numMountPoints = 0;
	skinColor = "0.029 0.029 0.029 1";

    useCustomPainEffects = true;
	PainHighImage = "PainHighImage";
	PainMidImage  = "PainMidImage";
	PainLowImage  = "PainLowImage";
	PainSound           = SpiderPainSound;
	DeathSound          = SpiderDeathSound;

	//Hole Attributes

	isHoleBot = 1;

	//Spawning option
	hSpawnTooClose = 0;//Doesn't spawn when player is too close and can see it
	  hSpawnTCRange = 8;//above range, set in brick units
	hSpawnClose = 0;//Only spawn when close to a player, can be used with above function as long as hSCRange is higher than hSpawnTCRange
	  hSpawnCRange = 32;//above range, set in brick units

	hType = Spider; //Enemy,Friendly, Neutral
	  hNeutralAttackChance = 100; //0 to 100, Chance that this type will attack neutral bots, ie horses/vehicles/civilians
	//can have unique types, nazis will attack zombies but nazis will not attack other bots labeled nazi
	hName = "Spider";//cannot contain spaces
	hTickRate = 3000;
	
	//Wander Options
	hWander = 1;//Enables random walking
	  hSmoothWander = 1;//This is in addition to regular wander, makes them walk a bit longer, and a bit smoother
	  hReturnToSpawn = 1;//Returns to spawn when too far
	  hSpawnDist = 48;//Defines the distance bot can travel away from spawnbrick
	  hGridWander = 0;//Locks the bot to a grid, overwrites other settings
	
	//Searching options
	hSearch = 1;//Search for Players
	  hSearchRadius = 64;//in brick units
	  hSight = 1;//Require bot to see player before pursuing
	  hStrafe = 0;//Randomly strafe while following player
	hSearchFOV = 0;//if enabled disables normal hSearch
	  hFOVRange = 0.7; // determines the angle we can see the player at, 0.7 is about normal fov for players, if 0 we can see all in front, if 1 we could only see someone perfectly ahead, can be negative
	  // hFOVRadius = 6; // no longer used, we now use searchRadius
	  hHearing = 1;//If it hears a player it'll look in the direction of the sound

	  hAlertOtherBots = 0;//Alerts other bots when he sees a player, or gets attacked

	//Attack Options
	hMelee = 1;//Melee
	  hAttackDamage = 10;//Melee Damage
	hShoot = 1;
	  hWep = "SpiderBiteItem";
	  hShootTimes = 4;//Number of times the bot will shoot between each tick
	  hMaxShootRange = 32;//The range in which the bot will shoot the player	//256
	  hAvoidCloseRange = 0;//
		hTooCloseRange = 7;//in brick units

	//Misc options
	hActivateDirection = 0; // 0 1 2, determines the direction you have to face the bot to activate him, both, front back
	hMoveSlowdown = 0; // bool, determines wether the bot will slow down when following enemies
	hAvoidObstacles = 1;
	hSuperStacker = 0;//When enabled makes the bots stack a bit better, in other words, jumping on each others heads to get to a player
	hSpazJump = 1;//Makes bot jump when the user their following is higher than them
	hAFKOmeter = 1;//Determines how often the bot will wander or do other idle actions, higher it is the less often he does things

	hIdle = 1;// Enables use of idle actions, actions which are done when the bot is not doing anything else
	  hIdleAnimation = 0;//Plays random animations/emotes, sit, click, love/hate/etc
	  hIdleLookAtOthers = 1;//Randomly looks at other players/bots when not doing anything else
	    hIdleSpam = 0;//Makes them spam click and spam hammer/spraycan
	  hSpasticLook = 1;//Makes them look around their environment a bit more.
	hEmote = 0;

	//Old Zombie mod code

//	FollowAnim = "ArmReadyBoth";
//	ZombieTeam = "Spiders";
//	NoBloodyHands = 1;
//	DoNotZombify = 1;
//	chance = 50;
//	SearchRadius = 70;
//	SpecialAttack = 1;
//	zDeathSound = "SpiderDeathSound";
//	ignorePipeBombs = 1;
//	aimatplayer = 1;
//	attackpower = 15;
//	BrickDestroyMaxVolume = 150;
//	BrickMaxJumpHeight = 15;
//	BrickKillRadius = 2;

};
//function SpiderHoleBot::SpecialAttack(%this,%onshot)
//{
//	if(getsimtime() >= %this.lastspecial+10 && %this.getstate() !$= "Dead")
//	{
//		%ran = getrandom(-1,1);
//		%ran2 = getrandom(-1,1);
//		%this.setmovex(%ran);
//		%this.setmovey(%ran2);
//		schedule(600,0,BotShootMode,%this);
//		schedule(500,0,BotShootMode,%this);
//		schedule(900,0,BotShootMode,%this);
//		schedule(1300,0,BotShootMode,%this);
//		%this.schedule(2800,clearmovex);
//		%this.schedule(2800,clearmovey);
//		%this.lastspecial = getsimtime();
//	}
//}
//function SpiderHoleBot::ondisabled(%this,%obj)
//{
//	parent::ondisabled(%this,%obj);
//	ZombieDefault::ondisabled(%this,%obj);
//}
//function SpiderHoleBot::onCollision(%this, %obj, %col, %fade, %pos, %norm)
//{
//	parent::oncollision(%this, %obj, %col, %fade, %pos, %norm);
//	ZombieDefault::onCollision(%this, %obj, %col, %fade, %pos, %norm);
//	if(IsInMinigame(%obj) && IsInSameMinigame(%col,%obj) && %obj.getstate() !$= "Dead" && %obj.spawnbrick.getgroup().client.minigame.EnableZombies == 1)
//	{
//		%col.applyimpulse(%col.getposition(),vectoradd(vectorscale(%obj.getforwardvector(),0),"0 0 0"));
//	}
//	if(IsInMinigame(%obj) && MinigameIncludesPlayerBricks(%col) && %col.iszombie && %obj.getstate() !$= "Dead")
//	{
//		%col.applyimpulse(%col.getposition(),vectoradd(vectorscale(%obj.getforwardvector(),0),"0 0 0"));
//		%obj.playthread(2,activate2);
//	}
//}
//function SpiderHoleBot::onMount(%a,%player,%vehicle,%d,%e,%f)
//{
//	ZombieDefault::onMount(%a,%player,%vehicle,%d,%e,%f);
//	parent::onMount(%a,%player,%vehicle,%d,%e,%f);
//}
//function SpiderHoleBot::onUnMount(%a,%player,%vehicle,%d,%e,%f)
//{
//	ZombieDefault::onUnMount(%a,%player,%vehicle,%d,%e,%f);
//	parent::onUnMount(%a,%player,%vehicle,%d,%e,%f);
//}
function SpiderHoleBot::onAdd(%this,%obj)
{
	armor::onAdd(%this,%obj);
//	parent::onAdd(%this,%obj);
//	ZombieDefault::onAdd(%this,%obj);
//	%obj.name = "Spider";
	schedule(15,0,recolorbug,%obj);
	
//	%obj.mountimage(SpiderBiteImage,0);
}

