// Load dts shapes and merge animations
datablock TSShapeConstructor(WormNEWDts)
{
	baseShape  = "./worm4.dts";
	sequence0  = "./wm_root.dsq root";

	sequence1  = "./wm_move.dsq run";
	sequence2  = "./wm_move.dsq walk";
	sequence3  = "./wm_move.dsq back";
	sequence4  = "./wm_move.dsq side";

	sequence5  = "./wm_dig.dsq crouch";
	sequence6  = "./wm_dig_move.dsq crouchRun";
	sequence7  = "./wm_dig_move.dsq crouchBack";
	sequence8  = "./wm_dig_move.dsq crouchSide";

	sequence9  = "./wm_root.dsq look";
	sequence10 = "./wm_headSide.dsq headside";
	sequence11 = "./wm_root.dsq headUp";

	sequence12 = "./wm_jump.dsq jump";
	sequence13 = "./wm_jump.dsq standjump";
	sequence14 = "./wm_fall.dsq fall";
	sequence15 = "./wm_root.dsq land";

	sequence16 = "./wm_attackLight.dsq armAttack";
	sequence17 = "./wm_root.dsq armReadyLeft";
	sequence18 = "./wm_root.dsq armReadyRight";
	sequence19 = "./wm_root.dsq armReadyBoth";
	sequence20 = "./wm_root.dsq spearready";  
	sequence21 = "./wm_root.dsq spearThrow";

	sequence22 = "./wm_attackLight.dsq talk";  

	sequence23 = "./wm_death1.dsq death1"; 
	
	sequence24 = "./wm_root.dsq shiftUp";
	sequence25 = "./wm_root.dsq shiftDown";
	sequence26 = "./wm_smash.dsq shiftAway";
	sequence27 = "./wm_root.dsq shiftTo";
	sequence28 = "./wm_root.dsq shiftLeft";
	sequence29 = "./wm_root.dsq shiftRight";
	sequence30 = "./wm_root.dsq rotCW";
	sequence31 = "./wm_root.dsq rotCCW";

	sequence32 = "./wm_root.dsq undo";
	sequence33 = "./wm_smash.dsq plant";

	sequence34 = "./wm_dig.dsq sit";

	sequence35 = "./wm_root.dsq wrench";

   sequence36 = "./wm_attackLight.dsq activate";
   sequence37 = "./wm_attackLight.dsq activate2";

   sequence38 = "./wm_root.dsq leftrecoil";
};    
datablock AudioProfile(WormPainSound)
{
   fileName = "./worm_pain.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(WormDeathSound)
{
   fileName = "./worm_death.wav";
   description = AudioClose3d;
   preload = true;
};

datablock fxDTSBrickData (BrickWormBot_HoleSpawnData)
{
	brickFile = "Add-ons/Bot_Hole/8xSpawn.blb";
	category = "Special";
	subCategory = "Holes";
	uiName = "Worm Hole";
	iconName = "Add-Ons/Bot_Blockhead/icon_blockhead";

	bricktype = 2;
	cancover = 0;
	orientationfix = 1;
	indestructable = 1;

	isBotHole = 1;
	holeBot = "WormHoleBot";
};

datablock PlayerData(WormHoleBot : PlayerStandardArmor)
{
//	category = Armor;
	shapeFile = "./worm4.dts";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 10;		//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;

	maxDamage = 1600;	//1800
	runforce = 100 * 5000;
	maxForwardSpeed = 4;
	maxBackwardSpeed = 4;
	maxSideSpeed = 0;
	jumpsound = "";
	
	maxForwardCrouchSpeed = 5;	//6
	maxBackwardCrouchSpeed = 3;
	maxSideCrouchSpeed = 1;

	boundingBox				= vectorScale("3.7 3.7 1.6", 4); //"3.75 3.75 2.4";
	crouchBoundingBox		= vectorScale("3.7 3.7 0.4", 4); //"3.75 3.75 2.4";
	proneBoundingBox		= vectorScale("3.7 3.7 1.6", 4); //"2.5 2.5 2.4";

	mass = 5000;
	maxStepHeight = 0.4;

	jumpForce = 6.95 * 5000; //8.3 * 90;
    jumpDelay = 0.3;	

//        minImpactSpeed = 160;
//        speedDamageScale = 4.8;

	uiName = "B1 Worm";
	rideable = false;
	canRide = false;
	paintable = true;
	numMountPoints = 0;
	skinColor = "0.039 0.267 0.000 1";

	isLargeEnemy = 1;
	flashImmune = 1;

    useCustomPainEffects = true;
	PainHighImage = "PainHighImage";
	PainMidImage  = "PainMidImage";
	PainLowImage  = "PainLowImage";
	PainSound           = WormPainSound;
	DeathSound          = WormDeathSound;
	//Hole Attributes

	isHoleBot = 1;

	//Spawning option
	hSpawnTooClose = 0;//Doesn't spawn when player is too close and can see it
	  hSpawnTCRange = 8;//above range, set in brick units
	hSpawnClose = 0;//Only spawn when close to a player, can be used with above function as long as hSCRange is higher than hSpawnTCRange
	  hSpawnCRange = 32;//above range, set in brick units

	hType = Worm; //Enemy,Friendly, Neutral
	  hNeutralAttackChance = 60; //0 to 100, Chance that this type will attack neutral bots, ie horses/vehicles/civilians
	//can have unique types, nazis will attack zombies but nazis will not attack other bots labeled nazi
	hName = "Worm";//cannot contain spaces
	hTickRate = 3000;
	
	//Wander Options
	hWander = 1;//Enables random walking
	  hSmoothWander = 1;//This is in addition to regular wander, makes them walk a bit longer, and a bit smoother
	  hReturnToSpawn = 1;//Returns to spawn when too far
	  hSpawnDist = 48;//Defines the distance bot can travel away from spawnbrick
	  hGridWander = 0;//Locks the bot to a grid, overwrites other settings
	
	//Searching options
	hSearch = 1;//Search for Players
	  hSearchRadius = 32;//in brick units	//64
	  hSight = 1;//Require bot to see player before pursuing
	  hStrafe = 0;//Randomly strafe while following player
	hSearchFOV = 0;//if enabled disables normal hSearch
	  hFOVRange = 0.7; // determines the angle we can see the player at, 0.7 is about normal fov for players, if 0 we can see all in front, if 1 we could only see someone perfectly ahead, can be negative
	  // hFOVRadius = 6; // no longer used, we now use searchRadius
	  hHearing = 1;//If it hears a player it'll look in the direction of the sound

	  hAlertOtherBots = 0;//Alerts other bots when he sees a player, or gets attacked

	//Attack Options
	hMelee = 1;//Melee
	  hAttackDamage = 20;//Melee Damage
	hShoot = 1;
	  hWep = "WormSmashItem";
	  hShootTimes = 4;//Number of times the bot will shoot between each tick
	  hMaxShootRange = 32;//The range in which the bot will shoot the player	//256
	  hAvoidCloseRange = 0;//
		hTooCloseRange = 7;//in brick units

	//Misc options
	hActivateDirection = 0; // 0 1 2, determines the direction you have to face the bot to activate him, both, front back
	hMoveSlowdown = 0; // bool, determines wether the bot will slow down when following enemies
	hAvoidObstacles = 1;
	hSuperStacker = 0;//When enabled makes the bots stack a bit better, in other words, jumping on each others heads to get to a player
	hSpazJump = 0;//Makes bot jump when the user their following is higher than them

	hAFKOmeter = 1;//Determines how often the bot will wander or do other idle actions, higher it is the less often he does things

	hIdle = 1;// Enables use of idle actions, actions which are done when the bot is not doing anything else
	  hIdleAnimation = 0;//Plays random animations/emotes, sit, click, love/hate/etc
	  hIdleLookAtOthers = 1;//Randomly looks at other players/bots when not doing anything else
	    hIdleSpam = 0;//Makes them spam click and spam hammer/spraycan
	  hSpasticLook = 1;//Makes them look around their environment a bit more.
	hEmote = 0;

	//Old Zombie Mod code

//	BrickDestroyMaxVolume = 150;
//	BrickMaxJumpHeight = 0;
//	BrickKillRadius = 2;
//	FollowAnim = "ArmReadyBoth";
//	ZombieTeam = "Worms";
//	NoBloodyHands = 1;
//	DoNotZombify = 1;
//	chance = 60;
//	SearchRadius = 40;
//	SpecialAttack = 1;
//	zDeathSound = "WormDeathSound";
//	ignorePipeBombs = 0;
//	attackpower = 25;

};

//function WormHoleBot::SpecialAttack(%this,%onshot)
//{
//	if(getsimtime() >= %this.lastspecial+500 && %this.getstate() !$= "Dead")
//	{
//		%ran = getrandom(-1,1);
//		%ran2 = getrandom(-1,1);
//		%this.setmovex(%ran);
//		%this.setmovey(%ran2);
//		schedule(600,0,BotShootMode,%this);
//		schedule(500,0,BotShootMode,%this);
//		schedule(900,0,BotShootMode,%this);
//		schedule(1300,0,BotShootMode,%this);
//		%this.schedule(2800,clearmovex);
//		%this.schedule(2800,clearmovey);
//		%this.lastspecial = getsimtime();
//	}
//}


//function WormHoleBot::ondisabled(%this,%obj)
//{
//	parent::ondisabled(%this,%obj);
//	ZombieDefault::ondisabled(%this,%obj);
//}
//function WormHoleBot::onCollision(%this, %obj, %col, %fade, %pos, %norm)
//{
//	parent::oncollision(%this, %obj, %col, %fade, %pos, %norm);
//	ZombieDefault::onCollision(%this, %obj, %col, %fade, %pos, %norm);
//	if(IsInMinigame(%obj) && IsInSameMinigame(%col,%obj) && %obj.getstate() !$= "Dead" && %obj.spawnbrick.getgroup().client.minigame.EnableZombies == 1)
//	{
//		%col.applyimpulse(%col.getposition(),vectoradd(vectorscale(%obj.getforwardvector(),0),"0 0 0"));
//	}
//	if(IsInMinigame(%obj) && MinigameIncludesPlayerBricks(%col) && %col.iszombie && %obj.getstate() !$= "Dead")
//	{
//		%col.applyimpulse(%col.getposition(),vectoradd(vectorscale(%obj.getforwardvector(),0),"0 0 0"));
//		%obj.playthread(2,activate2);
//	}
//}
//function WormHoleBot::onMount(%a,%player,%vehicle,%d,%e,%f)
//{
//	ZombieDefault::onMount(%a,%player,%vehicle,%d,%e,%f);
//	parent::onMount(%a,%player,%vehicle,%d,%e,%f);
//}
//function WormHoleBot::onUnMount(%a,%player,%vehicle,%d,%e,%f)
//{
//	ZombieDefault::onUnMount(%a,%player,%vehicle,%d,%e,%f);
//	parent::onUnMount(%a,%player,%vehicle,%d,%e,%f);
//}
function WormHoleBot::onAdd(%this,%obj)
{
	armor::onAdd(%this,%obj);
//	parent::onAdd(%this,%obj);
//	ZombieDefault::onAdd(%this,%obj);
//	%obj.name = "Worm";
	schedule(15,0,recolorbug,%obj);
//	%obj.mountimage(WormSmashImage,0);
}

