// Load dts shapes and merge animations
datablock TSShapeConstructor(DragonflyArmorDts)
{
	baseShape  = "./Dragon_Fly7.dts";
	sequence0  = "./dgnf_root.dsq root";

	sequence1  = "./dgnf_run.dsq run";
	sequence2  = "./dgnf_root.dsq walk";
	sequence3  = "./dgnf_root.dsq back";
	sequence4  = "./dgnf_root.dsq side";

	sequence5  = "./dgnf_root.dsq crouch";
	sequence6  = "./dgnf_run.dsq crouchRun";
	sequence7  = "./dgnf_root.dsq crouchBack";
	sequence8  = "./dgnf_root.dsq crouchSide";

	sequence9  = "./dgnf_root.dsq look";
	sequence10 = "./dgnf_root.dsq headside";
	sequence11 = "./dgnf_root.dsq headUp";

	sequence12 = "./dgnf_jump_fly.dsq jump";
	sequence13 = "./dgnf_jump_fly.dsq standjump";
	sequence14 = "./dgnf_fly_LOOP.dsq fall";
	sequence15 = "./dgnf_root.dsq land";

	sequence16 = "./dgnf_attack.dsq armAttack";
	sequence17 = "./dgnf_root.dsq armReadyLeft";
	sequence18 = "./dgnf_root.dsq armReadyRight";
	sequence19 = "./dgnf_root.dsq armReadyBoth";
	sequence20 = "./dgnf_root.dsq spearready";  
	sequence21 = "./dgnf_attack.dsq spearThrow";

	sequence22 = "./dgnf_root.dsq talk";  

	sequence23 = "./dgnf_death.dsq death1"; 
	
	sequence24 = "./dgnf_attack.dsq shiftUp";
	sequence25 = "./dgnf_root.dsq shiftDown";
	sequence26 = "./dgnf_attack.dsq shiftAway";
	sequence27 = "./dgnf_root.dsq shiftTo";
	sequence28 = "./dgnf_root.dsq shiftLeft";
	sequence29 = "./dgnf_root.dsq shiftRight";
	sequence30 = "./dgnf_root.dsq rotCW";
	sequence31 = "./dgnf_root.dsq rotCCW";

	sequence32 = "./dgnf_root.dsq undo";
	sequence33 = "./dgnf_attack.dsq plant";

	sequence34 = "./dgnf_pose.dsq sit";

	sequence35 = "./dgnf_attack.dsq wrench";

   sequence36 = "./dgnf_attack.dsq activate";
   sequence37 = "./dgnf_attack.dsq activate2";

   sequence38 = "./dgnf_attack.dsq leftrecoil";
   
//   sequence39 = "./dgnf_pinchReady.dsq stingReady";	//stingReady so it will work with scorpion sting weapons
   sequence39 = "./dgnf_fly.dsq Fly";
};    

datablock PlayerData(DragonflyArmor : PlayerStandardArmor)
{
	//category = "Vehicles";
	shapeFile = "./Dragon_Fly7.dts";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	runforce = 120 * 90;		//100 * 90
	maxForwardSpeed = 11;
	maxBackwardSpeed = 11;
	maxSideSpeed = 11;
	maxForwardCrouchSpeed = 10;
	maxBackwardCrouchSpeed = 9;
	maxSideCrouchSpeed = 7;
	jumpForce = 10 * 90; //8.3 * 90;
    jumpDelay = 0;
	//jumpsound = "ArmorJumpSound";
	cameradefaultFOV = 90;
	cameraMaxFov = 120;
	cameraMinFov = 10;
	//minlookangle = -1;
	//maxlookangle = -1;
	minlookangle = -1.5708;
	maxlookangle = 1.5708;
	uiName = "B2 Dragonfly";
	rideable = true;

	maxDamage = 150;	//250
	jumpsound = "";
	paintable = true;

	boundingBox				= vectorScale("2.8 2.8 1.2", 4); //"2.5 2.5 2.4";
    crouchBoundingBox		= vectorScale("2.8 2.8 1.2", 4); //"2.5 2.5 2.4";
    proneBoundingBox		= vectorScale("2.8 2.8 1.2", 4); //"2.5 2.5 2.4";
	mass = 90;
	drag = 0.04;
    minImpactSpeed = 160;
	speedDamageScale = 0.5;    
	numMountPoints = 0;
	airControl		= 1;
//	maxStepHeight = 0.5;

//	isLargeEnemy = 1;

	maxEnergy = 100;
	rechargeRate = 1;
	showEnergyBar = true;

};

function DragonflyArmor::onTrigger(%this, %obj, %trig, %press) {
	if(%trig == 2 && %press && getsimtime() >= %obj.lastjump+200)
	{
		//flap code goes here. What follows is a recreation of the standard jump on a standard armor MINUS a check to be sure we're touching the ground - flying is possible with this.

		//pretty sure it doesn't play a sound either, because, again, I didn't need it for my purposes.
		%obj.forbidJump = true;
		%obj.addVelocity("0 0 8");	//7
		%obj.playThread(0, "Fly"); //animation
//		ServerPlay3D(AirDragonJumpSound, %obj.getPosition());
		%obj.lastjump = getsimtime();
	}
	else Parent::onTrigger(%this, %obj, %trig, %press);
}

function allowJump(%obj) {
	if(!isObject(%obj)) 
		return;
	%obj.forbidJump = false;
}
