// Load dts shapes and merge animations
datablock TSShapeConstructor(EarwigDts)
{
	baseShape  = "./earwig4.dts";
	sequence0  = "./erwg_root.dsq root";

	sequence1  = "./erwg_run.dsq run";
	sequence2  = "./erwg_run.dsq walk";
	sequence3  = "./erwg_back.dsq back";
	sequence4  = "./erwg_side.dsq side";

	sequence5  = "./erwg_crouch.dsq crouch";
	sequence6  = "./erwg_crouchMove.dsq crouchRun";
	sequence7  = "./erwg_crouchBack.dsq crouchBack";
	sequence8  = "./erwg_crouchSide.dsq crouchSide";

	sequence9  = "./erwg_root.dsq look";
	sequence10 = "./erwg_root.dsq headside";
	sequence11 = "./erwg_root.dsq headUp";

	sequence12 = "./erwg_jump.dsq jump";
	sequence13 = "./erwg_jump.dsq standjump";
	sequence14 = "./erwg_fly_fall.dsq fall";
	sequence15 = "./erwg_root.dsq land";

	sequence16 = "./erwg_root.dsq armAttack";
	sequence17 = "./erwg_root.dsq armReadyLeft";
	sequence18 = "./erwg_root.dsq armReadyRight";
	sequence19 = "./erwg_root.dsq armReadyBoth";
	sequence20 = "./erwg_root.dsq spearready";  
	sequence21 = "./erwg_pinch.dsq spearThrow";

	sequence22 = "./erwg_bite.dsq talk";  

	sequence23 = "./erwg_death.dsq death1"; 
	
	sequence24 = "./erwg_root.dsq shiftUp";
	sequence25 = "./erwg_root.dsq shiftDown";
	sequence26 = "./erwg_root.dsq shiftAway";
	sequence27 = "./erwg_root.dsq shiftTo";
	sequence28 = "./erwg_root.dsq shiftLeft";
	sequence29 = "./erwg_root.dsq shiftRight";
	sequence30 = "./erwg_root.dsq rotCW";
	sequence31 = "./erwg_root.dsq rotCCW";

	sequence32 = "./erwg_root.dsq undo";
	sequence33 = "./erwg_bite.dsq plant";

	sequence34 = "./erwg_fightingStance.dsq sit";

	sequence35 = "./erwg_root.dsq wrench";

   sequence36 = "./erwg_bite.dsq activate";
   sequence37 = "./erwg_bite.dsq activate2";

   sequence38 = "./erwg_root.dsq leftrecoil";
   
   sequence39 = "./erwg_pinchReady.dsq stingReady";	//stingReady so it will work with scorpion sting weapons
   sequence40 = "./erwg_fly.dsq Fly";
};    

datablock PlayerData(EarwigZombie : PlayerStandardArmor)
{
	//category = "Vehicles";
	shapeFile = "./earwig4.dts";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	runforce = 50 * 90;
	maxForwardSpeed = 8;
	maxBackwardSpeed = 7;
	maxSideSpeed = 7;
	maxForwardCrouchSpeed = 7;
	maxBackwardCrouchSpeed = 6.5;
	maxSideCrouchSpeed = 6.5;
	jumpForce = 10 * 90; //8.3 * 90;
    jumpDelay = 0;
	attackpower = 33;	//25
	//jumpsound = "ZombieJumpSound";
	cameradefaultFOV = 90;
	cameraMaxFov = 120;
	cameraMinFov = 10;
	//minlookangle = -1;
	//maxlookangle = -1;
	minlookangle = -1.5708;
	maxlookangle = 1.5708;
	BrickDestroyMaxVolume = 250;
	BrickMaxJumpHeight = 3;
	uiName = "B2 Earwig";
	rideable = true;

	boundingBox				= vectorScale("2.8 2.8 1.0", 4); //"2.5 2.5 2.4";
    crouchBoundingBox		= vectorScale("2.8 2.8 0.7", 4); //"2.5 2.5 2.4";
    proneBoundingBox		= vectorScale("2.8 2.8 1.0", 4); //"2.5 2.5 2.4";
//	mass = 50;
    minImpactSpeed = 160;
	speedDamageScale = 0.5;    
	numMountPoints = 0;
	airControl		= 0.45;
	maxStepHeight = 0.5;

	isLargeEnemy = 1;

};

function EarwigZombie::onTrigger(%this, %obj, %trig, %press) {
	if(%trig == 2 && %press && getsimtime() >= %obj.lastjump+200)
	{
		//flap code goes here. What follows is a recreation of the standard jump on a standard armor MINUS a check to be sure we're touching the ground - flying is possible with this.

		//pretty sure it doesn't play a sound either, because, again, I didn't need it for my purposes.
		%obj.forbidJump = true;
		%obj.addVelocity("0 0 5");	//10
		%obj.playThread(0, "Fly"); //animation
//		ServerPlay3D(AirDragonJumpSound, %obj.getPosition());
		%obj.lastjump = getsimtime();
	}
	else Parent::onTrigger(%this, %obj, %trig, %press);
}

function allowJump(%obj) {
	if(!isObject(%obj)) 
		return;
	%obj.forbidJump = false;
}
