// Load dts shapes and merge animations
datablock TSShapeConstructor(FireflyZombieDts)
{
	baseShape  = "./firefly7.dts";
	sequence0  = "./fy2_root.dsq root";

	sequence1  = "./fy2_run.dsq run";
	sequence2  = "./fy2_run.dsq walk";
	sequence3  = "./fy2_back.dsq back";
	sequence4  = "./fy2_root.dsq side";

	sequence5  = "./fy2_root.dsq crouch";
	sequence6  = "./fy2_run.dsq crouchRun";
	sequence7  = "./fy2_back.dsq crouchBack";
	sequence8  = "./fy2_root.dsq crouchSide";

	sequence9  = "./fy2_look.dsq look";
	sequence10 = "./fy2_root.dsq headside";
	sequence11 = "./fy2_root.dsq headUp";

	sequence12 = "./fy2_jumpfly.dsq jump";
	sequence13 = "./fy2_jumpfly.dsq standjump";
	sequence14 = "./fy2_flyloop.dsq fall";
	sequence15 = "./fy2_root.dsq land";

	sequence16 = "./fy2_attack.dsq armAttack";
	sequence17 = "./fy2_root.dsq armReadyLeft";
	sequence18 = "./fy2_root.dsq armReadyRight";
	sequence19 = "./fy2_root.dsq armReadyBoth";
	sequence20 = "./fy2_root.dsq spearready";  
	sequence21 = "./fy2_attack.dsq spearThrow";

	sequence22 = "./fy2_root.dsq talk";  

	sequence23 = "./fy2_death1.dsq death1"; 
	
	sequence24 = "./fy2_root.dsq shiftUp";
	sequence25 = "./fy2_root.dsq shiftDown";
	sequence26 = "./fy2_root.dsq shiftAway";
	sequence27 = "./fy2_root.dsq shiftTo";
	sequence28 = "./fy2_root.dsq shiftLeft";
	sequence29 = "./fy2_root.dsq shiftRight";
	sequence30 = "./fy2_root.dsq rotCW";
	sequence31 = "./fy2_root.dsq rotCCW";

	sequence32 = "./fy2_root.dsq undo";
	sequence33 = "./fy2_attack.dsq plant";

	sequence34 = "./fy2_root.dsq sit";

	sequence35 = "./fy2_attack.dsq wrench";

   sequence36 = "./fy2_attack.dsq activate";
   sequence37 = "./fy2_attack.dsq activate2";

   sequence38 = "./fy2_root.dsq leftrecoil";

   sequence39 = "./fy2_fly.dsq Fly";
   sequence40 = "./fy2_light_glow.dsq lightGlow";
   sequence40 = "./fy2_flash.dsq Flash";
};    

 datablock PlayerData(FireflyZombie : PlayerStandardArmor)
{
	//category = "Vehicles";
	shapeFile = "./firefly7.dts";
//	mass = 60;
	drag = 0.5;		//0.8

	cameraMaxDist = 6;
	cameraTilt = 0.1;//0.174 * 2.5; //~25 degrees
	cameraVerticalOffset = 2;

	cameradefaultFOV = 90;
	cameraMaxFov = 120;
	cameraMinFov = 10;

	//minlookangle = -1;
	//maxlookangle = -1;
	minlookangle = -1.2;
	maxlookangle = 1.2;

	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
//	jetForce = 2000;

	jumpForce = 16 * 90; //20 * 90;
	jumpDelay = 0;
	jumpsound = "";

	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;

	maxDamage = 120;

//	runforce = 100 * 90;
	maxForwardSpeed = 10;
	maxBackwardSpeed = 8;
	maxSideSpeed = 8;
	attackpower = 18;
	
	maxForwardCrouchSpeed = 8;
	maxBackwardCrouchSpeed = 8;
	maxSideCrouchSpeed = 8;

	boundingBox			= vectorScale("2.4 2.4 0.8", 4); //"2.5 2.5 2.4";
	crouchBoundingBox	= vectorScale("2.4 2.4 0.8", 4); //"2.5 2.5 2.4";
	proneBoundingBox	= vectorScale("2.4 2.4 0.8", 4); //"2.5 2.5 2.4";

	maxStepHeight = 0.3;

	BrickDestroyMaxVolume = 50;
	BrickMaxJumpHeight = 5;

	uiName = "B2 Firefly";
	rideable = true;

	airControl = 0.6;

    minImpactSpeed = 160;
	speedDamageScale = 0.5;

	maxEnergy = 100;
	rechargeRate = 1;
	showEnergyBar = true;

};

function FireFlyZombie::onTrigger(%this, %obj, %trig, %press) {
	if(%trig == 2 && %press && getsimtime() >= %obj.lastjump+200)
	{
		//flap code goes here. What follows is a recreation of the standard jump on a standard armor MINUS a check to be sure we're touching the ground - flying is possible with this.

		//pretty sure it doesn't play a sound either, because, again, I didn't need it for my purposes.
		%obj.forbidJump = true;
		%obj.addVelocity("0 0 10");
		%obj.playThread(0, "Fly"); //animation
//		ServerPlay3D(AirDragonJumpSound, %obj.getPosition());
		%obj.lastjump = getsimtime();
	}
	else Parent::onTrigger(%this, %obj, %trig, %press);
}

function allowJump(%obj) {
	if(!isObject(%obj)) 
		return;
	%obj.forbidJump = false;
}

