
//Bash Effects//
////////////////

datablock ParticleData(FireFlyBashHitParticle)
{
	dragCoefficient      = 1.5;
	gravityCoefficient   = 0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	spinRandomMin 	     = -90;
	spinRandomMax 		= 90;
	lifetimeMS           = 200;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/dot";
	colors[0]     = "0.7 0.7 0.65 0.9";
	colors[1]     = "0.3 0.3 0.3 0.1";
	sizes[0]      = 0.28;
	sizes[1]      = 0.1;
	times[0]	  = 0.0;
	times[1]	  = 1.0;

	useInvAlpha = true;
};

datablock ParticleEmitterData(FireFlyBashHitEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 1;
   ejectionVelocity = 4;
   velocityVariance = 1.0;
   ejectionOffset   = 1;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FireFlyBashHitParticle";

   uiName = "Firefly Bash";
};


//FireflyFlash Effects//
///////////////////////

datablock ParticleData(FireFlyFlashBeamParticle)
{
	dragCoefficient      = 0.0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	spinRandomMin 	     = -90;
	spinRandomMax 		= 90;
	lifetimeMS           = 600;		//500
	lifetimeVarianceMS   = 100;		//50
	textureName          = "base/data/particles/dot";
	colors[0]     = "0.9 1.0 0.9 0.7";
	colors[1]     = "0.8 1.0 0.8 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.0;
	times[0]	  = 0.0;
	times[1]	  = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(FireFlyFlashBeamEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0.5;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FireFlyFlashBeamParticle";

   uiName = "Firefly Flash Beam";
};

datablock ParticleData(FireFlyFlashParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	spinRandomMin 	     = -90;
	spinRandomMax 		= 90;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/dot";
	colors[0]     = "0.95 1.0 0.8 0.5";
	colors[1]     = "0.7 1.0 0.5 0.0";
	sizes[0]      = 1.0;		//1.5
	sizes[1]      = 3;		//2.5
	times[0]	  = 0.0;
	times[1]	  = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(FireFlyFlashEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 1;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "FireFlyFlashParticle";

   uiName = "Firefly Flash";
};

datablock DebrisData(FireFlyFlashDebris)
{
	emitters = "FireFlyFlashBeamEmitter";

//	shapeFile = "./emptywheel.dts";
	shapeFile = "base/data/shapes/empty.dts";
	lifetime = 0.05;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 0;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = false;

	gravModifier = 0;
};


//Slash Effects//
/////////////////

datablock ParticleData(MantisSlashHitParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	spinRandomMin 	     = -90;
	spinRandomMax 		= 90;
	lifetimeMS           = 150;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/star1";
	colors[0]     = "0.8 1.0 0.6 0.7";
	colors[1]     = "0.6 1.0 0.4 0.4";
//	colors[2]     = "0.2 0.6 1.0 0.1";
	sizes[0]      = 0.4;
	sizes[1]      = 2.0;
//	sizes[2]      = 0.1;
	times[0]	  = 0.0;
//	times[1]	  = 0.01;
	times[1]	  = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(MantisSlashHitEmitter)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 3;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MantisSlashHitParticle";

   uiName = "Mantis Slash hit";
};