//Item_BugBoost.cs

//audio
//datablock AudioProfile(rocketFireSound)
//{
//   filename    = "./rocketFire.wav";
//   description = AudioClosest3d;
//   preload = true;
//};

//datablock AudioProfile(rocketExplodeSound)
//{
//   filename    = "./tntExplode.wav";
//   description = AudioDefault3d;
//   preload = true;
//};
//datablock AudioProfile(rocketLoopSound)
//{
//   filename    = "./rocketLoop.wav";
//   description = AudioCloseLooping3d;
//   preload = true;
//};

//trail effects
datablock ParticleData(BugBoostTrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.15;
	constantAcceleration = 0.0;
	lifetimeMS           = 1500;
	lifetimeVarianceMS   = 800;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 50.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "1.0 1.0 1.0 0.1";
	colors[1]     = "0.0 0.0 0.1 0.0";
//	colors[2]     = "0.20 0.20 0.20 0.3";
//	colors[3]     = "0.0 0.0 0.0 0.0";

	sizes[0]      = 3.0;
	sizes[1]      = 0.2;
//	sizes[2]      = 0.35;
//	sizes[3]      = 0.05;

	times[0] = 0.0;
	times[1] = 1.0;
//	times[2] = 0.3;
//	times[3] = 1.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(BugBoostTrailEmitter)
{
	ejectionPeriodMS = 5;
	periodVarianceMS = 1;
	ejectionVelocity = 0.0;
	velocityVariance = 0.0;
	ejectionOffset   = 2.5;
	thetaMin         = 0;
	thetaMax         = 90;
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = "BugBoostTrailParticle";

	uiName = "Bug Boost Trail";
};

//datablock ExplosionData(rocketExplosion)
//{
   //explosionShape = "";
//   explosionShape = "./explosionSphere1.dts";
//	soundProfile = rocketExplodeSound;

//   lifeTimeMS = 150;

//   particleEmitter = rocketExplosionEmitter;
//   particleDensity = 10;
//   particleRadius = 0.2;

//   emitter[0] = rocketExplosionRingEmitter;

//   faceViewer     = true;
//   explosionScale = "1 1 1";

//   shakeCamera = true;
//   camShakeFreq = "10.0 11.0 10.0";
//   camShakeAmp = "3.0 10.0 3.0";
//   camShakeDuration = 0.5;
//   camShakeRadius = 20.0;
//
   // Dynamic light
//   lightStartRadius = 5;
//   lightEndRadius = 20;
//   lightStartColor = "1 1 1 1";
//   lightEndColor = "0 0 0 0";

//   damageRadius = 3;
//   radiusDamage = 100;
//
//   impulseRadius = 6;
//   impulseForce = 4000;
//};


//AddDamageType("RocketDirect",   '<bitmap:add-ons/Weapon_Rocket_Launcher/CI_rocket> %1',    '%2 <bitmap:add-ons/Weapon_Rocket_Launcher/CI_rocket> %1',1,1);
//AddDamageType("RocketRadius",   '<bitmap:add-ons/Weapon_Rocket_Launcher/CI_rocketRadius> %1',    '%2 <bitmap:add-ons/Weapon_Rocket_Launcher/CI_rocketRadius> %1',1,0);
//datablock ProjectileData(BugBoostProjectile)
//{
//	projectileShapeName = "base/data/shapes/empty.dts";
   //	projectileShapeName = "./RocketProjectile.dts";
//	directDamage        = 0;
//	directDamageType = $DamageType::RocketDirect;
//	radiusDamageType = $DamageType::RocketRadius;
//	impactImpulse	   = 0;
//	verticalImpulse	   = 0;
//	explosion           = rocketExplosion;
//	particleEmitter     = rocketTrailEmitter;

//   brickExplosionRadius = 0;
//   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
//  brickExplosionForce  = 0;             
//   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
//   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

//   sound = rocketLoopSound;

//   muzzleVelocity      = 10;
//   velInheritFactor    = 0;

//   armingDelay         = 00;
//   lifetime            = 100;
//   fadeDelay           = 0;
//   bounceElasticity    = 0;
//   bounceFriction      = 0;
//   isBallistic         = false;
//   gravityMod = 0.0;

//   hasLight    = true;
//   lightRadius = 5.0;
//   lightColor  = "1 0.5 0.0";

//   uiName = "Rocket";
//};

//////////
// item //
//////////
datablock ItemData(BugBoostItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
//	emap = true;

	//gui stuff
	uiName = "Bug Boost";
//	iconName = "./icon_rocketLauncher";
	doColorShift = true;
	colorShiftColor = "0.0 0.80 0.0 1.000";

	 // Dynamic properties defined by the scripts
	image = BugBoostImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(BugBoostImage)
{
   // Basic Item properties
//   shapeFile = "./rocketLauncher.dts";
	shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
//   projectile = ;
//   projectileType = Projectile;

	//casing = rocketLauncherShellDebris;
//	shellExitDir        = "1.0 -1.3 1.0";
//	shellExitOffset     = "0 0 0";
//	shellExitVariance   = 15.0;	
//	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
	melee = true;
   //raise your arm up or not
	armReady = false;

//	minShotTime = 2000;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

	energyUsage = 100;

   doColorShift = true;
   colorShiftColor = rocketLauncherItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.05;
	stateTransitionOnTimeout[0]       = "Ready";
//	stateSound[0]					= weaponSwitchSound;

	stateName[1]					= "Ready";
	stateTransitionOnTriggerDown[1]	= "EnergyCheck";
	stateAllowImageChange[1]		= true;
//	stateScript[1]					= "onReady";
//   stateTransitionOnNoAmmo[1]		= "NoAmmo";
//	stateSequence[1]				= "Ready";
	
	stateName[2]					= "EnergyCheck";
	stateScript[2]					= "onEnergyCheck";
//	stateTransitionOnNoAmmo[2]		= "Recharge";
	stateTransitionOnTimeout[2]		= "Prefire";
//	stateTransitionOnTriggerDown[2]	= "Prefire";
	stateTimeoutValue[2]            = 0.001;
	stateAllowImageChange[2]		= false;

	stateName[3]					= "Prefire";
//	stateScript[3]					= "onPrefire";
	stateTransitionOnNoAmmo[3]		= "Ready";
//	stateTransitionOnTimeout[3]		= "Fire1";
	stateTransitionOnTriggerDown[3]	= "Fire1";
//	stateTimeoutValue[3]            = 0.05;
	stateAllowImageChange[3]		= false;

	stateName[4]                    = "Fire1";
	stateTransitionOnTimeout[4]     = "Fire2";
	stateTimeoutValue[4]            = 0.05;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
//	stateSequence[4]                = "Fire";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;
	stateEmitter[4]					= BugBoostTrailEmitter;
	stateEmitterTime[4]				= 0.3;
	stateEmitterNode[4]				= "muzzleNode";
//	stateSound[4]					= rocketFireSound;
//   stateSequence[4]                = "Fire";

	stateName[5]					= "Fire2";
	stateTransitionOnTimeout[5]		= "Recharge";
	stateTimeoutValue[5]			= 0.25;
	stateFire[5]					= true;
	stateAllowImageChange[5]		= false;
//	stateSequence[5]				= "Fire";
	stateScript[5]					= "onFire";
	stateWaitForTimeout[5]			= true;
//	stateEmitter[5]					= BugBoostTrailEmitter;
//	stateEmitterTime[5]				= 0.1;
//	stateEmitterNode[5]				= "MuzzleNode";
//	stateSound[5]					= rocketFireSound;
//	stateSequence[5]				= "Fire";

//	stateName[4]                    = "Fire3";
//	stateTransitionOnTimeout[4]     = "Recharge";
//	stateTimeoutValue[4]            = 0.1;
//	stateFire[4]                    = true;
//	stateAllowImageChange[4]        = false;
////	stateSequence[4]                = "Fire";
//	stateScript[4]                  = "onFire";
//	stateWaitForTimeout[4]			= true;
//	stateEmitter[4]					= BugBoostTrailEmitter;
//	stateEmitterTime[4]				= 0.2;
//	stateEmitterNode[4]				= "MuzzleNode";
////	stateSound[4]					= rocketFireSound;
////   stateSequence[4]                = "Fire";

	stateName[6] 					= "Recharge";
	stateTimeoutValue[6]            = 0.4;
	stateTransitionOnTimeout[6]     = "Ready";
	stateWaitForTimeout[6]			= true;
	stateAllowImageChange[6]        = true;
//	stateScript[6]                  = "onRecharge";

};

function BugBoostImage::onEnergyCheck(%this,%obj,%slot)
{
//	echo("ENGI CHECK");

	if(%obj.getEnergyLevel() >= %this.energyUsage)
	{
		%obj.setImageAmmo(%slot,1);

	} else {
		%obj.setImageAmmo(%slot,0);
		centerprint(%obj.client,"<color:ffffff>You need more energy to boost!" ,2);
	}
}

//function BugBoostImage::onPrefire(%this,%obj,%slot)
//{
//	if(%obj.getEnergyLevel() < %this.energyUsage)
//	echo("ENGI CHECK");
//}

function BugBoostImage::onFire(%this,%obj,%slot)
{
//	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
//		return;

	if(%obj.getEnergyLevel() >= 50)
	{

		%obj.lastFireTime = getSimTime();

		%obj.setEnergyLevel(%obj.getEnergyLevel() - 50);

		%fvec = %obj.getForwardVector();
		%fX = getWord(%fvec,0);
		%fY = getWord(%fvec,1);
  
		%evec = %obj.getEyeVector();
		%eX = getWord(%evec,0);
		%eY = getWord(%evec,1);
		%eZ = getWord(%evec,2);
		
		%eXY = mSqrt(%eX*%eX+%eY*%eY);
  
		%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;

		%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%aimVec,"20")));

//		%obj.setImageAmmo(%slot,0);
	}
}

//function BugBoostImage::onFire2(%this,%obj,%slot)
//{
//	if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
//		return;

//	if(%obj.getEnergyLevel() >= %this.energyUsage)
//	{

//		%obj.lastFireTime = getSimTime();

//		%obj.setEnergyLevel(%obj.getEnergyLevel() - 45);

//		%fvec = %obj.getForwardVector();
//		%fX = getWord(%fvec,0);
//		%fY = getWord(%fvec,1);
  
//		%evec = %obj.getEyeVector();
//		%eX = getWord(%evec,0);
//		%eY = getWord(%evec,1);
//		%eZ = getWord(%evec,2);
		
//		%eXY = mSqrt(%eX*%eX+%eY*%eY);
  
//		%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;

//		%obj.setVelocity(VectorAdd(%obj.getVelocity(),VectorScale(%aimVec,"18")));

//	} else {
//		centerprint(%obj.client,"<color:ffffff>You need more energy to boost!" ,2);	
//	}

//}


