//Item_FF_Light.cs

//effects
//datablock ParticleData(FireFlyLightParticle)
//{
//	dragCoefficient      = 2;
//	gravityCoefficient   = 0.0;
//	inheritedVelFactor   = 0.2;
//	constantAcceleration = 0.0;
//	spinRandomMin 	     = -90;
//	spinRandomMax 		= 90;
//	lifetimeMS           = 800;
//	lifetimeVarianceMS   = 300;
//	textureName          = "base/data/particles/dot";
//	colors[0]     = "0.2 0.8 0.0 0.1";
//	colors[1]     = "0.0 0.5 0.0 0.0";
//	sizes[0]      = 1.5;
//	sizes[1]      = 0.1;
//	times[0]	  = 0.0;
//	times[1]	  = 1.0;

//	useInvAlpha = false;
//};

//datablock ParticleEmitterData(FireFlyLightEmitter)
//{
//   ejectionPeriodMS = 10;
//   periodVarianceMS = 1;
//   ejectionVelocity = 0;
//   velocityVariance = 0;
//   ejectionOffset   = 0.2;
//   thetaMin         = 0;
//   thetaMax         = 180;
//   phiReferenceVel  = 0;
//   phiVariance      = 360;
//   overrideAdvance = false;
//   particles = "FireFlyLightParticle";

//   uiName = "Firefly Light";
//};

//////////
// item //
//////////
datablock ItemData(FireFlyLightItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	// Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	//gui stuff
	uiName = "Firefly Light";
//	iconName = "./icon_FireFlyBash";
//	doColorShift = false;
//	colorShiftColor = "0.471 0.471 0.471 1.000";

	// Dynamic properties defined by the scripts
	image = FireFlyLightImage;
	canDrop = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(FireFlyLightImage)
{
   // Basic Item properties
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = FireFlyBashProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = false;

	hasLight	= true;
	lightType	= "ConstantLight";
	lightColor	= "0.5 1 0";
	lightRadius	= 10;


   //casing = " ";
//   doColorShift = false;
//   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
//	stateTimeoutValue[0]             = 0.2;
//	stateTransitionOnTimeout[0]      = "Idle";
//	stateSound[0]                    = swordDrawSound;
	stateScript[0]                 = "onActivate";

//	stateName[1]                     = "Idle";
//	stateAllowImageChange[1]         = true;
//	stateEmitter[1]                = FireFlyLightEmitter;
//	stateEmitterTime[1]            = 100;
};

function FireFlyLightImage::onActivate(%this, %obj, %slot)
{
//	Parent::onActivate(%this,%obj,%slot);

	%obj.playthread(2, lightGlow);
}

function FireFlyLightImage::onMount(%this, %obj, %slot)
{
	   Parent::onMount(%this, %obj, %slot);
//	      %obj.playThread(1, armreadyboth);
}
function FireflyLightImage::onUnMount(%this, %obj, %slot)
{
	   Parent::onUnMount(%this, %obj, %slot);
}


