// Load dts shapes and merge animations
datablock TSShapeConstructor(BigBugDts)
{
	baseShape  = "./bigBug5.dts";
	sequence0  = "./bigB_root.dsq root";

	sequence1  = "./bigB_run.dsq run";
	sequence2  = "./bigB_run.dsq walk";
	sequence3  = "./bigB_back.dsq back";
	sequence4  = "./bigB_side.dsq side";

	sequence5  = "./bigB_root.dsq crouch";
	sequence6  = "./bigB_run.dsq crouchRun";
	sequence7  = "./bigB_back.dsq crouchBack";
	sequence8  = "./bigB_side.dsq crouchSide";

	sequence9  = "./bigB_look.dsq look";
	sequence10 = "./bigB_root.dsq headside";
	sequence11 = "./bigB_root.dsq headUp";

	sequence12 = "./bigB_jump.dsq jump";
	sequence13 = "./bigB_jumpstand.dsq standjump";
	sequence14 = "./bigB_fall.dsq fall";
	sequence15 = "./bigB_land.dsq land";

	sequence16 = "./bigB_attack.dsq armAttack";
	sequence17 = "./bigB_root.dsq armReadyLeft";
	sequence18 = "./bigB_root.dsq armReadyRight";
	sequence19 = "./bigB_root.dsq armReadyBoth";
	sequence20 = "./bigB_root.dsq spearready";  
	sequence21 = "./bigB_root.dsq spearThrow";

	sequence22 = "./bigB_talk.dsq talk";  

	sequence23 = "./bigB_death1.dsq death1"; 
	
	sequence24 = "./bigB_root.dsq shiftUp";
	sequence25 = "./bigB_root.dsq shiftDown";
	sequence26 = "./bigB_attack.dsq shiftAway";
	sequence27 = "./bigB_root.dsq shiftTo";
	sequence28 = "./bigB_root.dsq shiftLeft";
	sequence29 = "./bigB_root.dsq shiftRight";
	sequence30 = "./bigB_root.dsq rotCW";
	sequence31 = "./bigB_root.dsq rotCCW";

	sequence32 = "./bigB_root.dsq undo";
	sequence33 = "./bigB_land.dsq plant";

	sequence34 = "./bigB_death1.dsq sit";

	sequence35 = "./bigB_attack.dsq wrench";

   sequence36 = "./bigB_attack.dsq activate";
   sequence37 = "./bigB_attack.dsq activate2";

   sequence38 = "./bigB_root.dsq leftrecoil";
};    

//datablock AudioProfile(BugPainSound)
//{
//   fileName = "./bigB_pain.wav";
//   description = AudioClose3d;
//   preload = true;
//};
//datablock AudioProfile(BugDeathSound)
//{
//   fileName = "./bigB_death.wav";
//   description = AudioClose3d;
//   preload = true;
//};

datablock PlayerData(BigBug : PlayerStandardArmor)
{
//	category = Armor;
	shapeFile = "./bigBug5.dts";

	cameraMaxDist = 4;
	cameraTilt = 0.1;//0.174 * 2.5; //~25 degrees
    cameraVerticalOffset = 1;
	computeCRC = false;
	
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 10;		//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;

	maxDamage = 100;	//70
	runforce = 60 * 75;	//50 * 90
	maxForwardSpeed = 6.5;	//3.8
	maxBackwardSpeed = 5;	//3
	maxSideSpeed = 4;		//2
//	attackpower = 25;
	jumpsound = "";
	
    boundingBox				= vectorScale("1.3 1.3 0.8", 4); //"2.5 2.5 2.4";
    crouchBoundingBox		= vectorScale("1.3 1.3 0.8", 4); //"2.5 2.5 2.4";
    proneBoundingBox		= vectorScale("1.3 1.3 0.8", 4); //"2.5 2.5 2.4";
	
	maxForwardCrouchSpeed = 2;
	maxBackwardCrouchSpeed = 2;
	maxSideCrouchSpeed = 1.5;

	mass = 75;

	jumpForce = 6.5 * 90; //6 * 90;
    jumpDelay = 0.5;

	maxStepHeight = 0.4;

	minImpactSpeed = 25;	//20
	speedDamageScale = 3;	//4.3

	useCustomPainEffects = true;
	PainSound			= BugPainSound;
	DeathSound			= BugDeathSound;

	BrickDestroyMaxVolume = 150;
	BrickMaxJumpHeight = 0;
	uiName = "B4 Big Bug";
	rideable = false;	//true
};