datablock itemdata(tinyManaPotionItem)
{
	category = "Item";  // Mission editor category
	className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./jar-b-s.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Tiny Mana Potion";
	iconName = "";
	doColorShift = false;
	// colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = tinyManaPotionImage;
	canDrop = true;
};

datablock shapeBaseImageData(tinyManaPotionImage)
{
	// Basic Item properties
   shapeFile = "./jar-b-s.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = tinyManaPotionItem;
   ammo = " ";
   projectile = "";
   projectileType = NONE;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   // colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = weaponShiftSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;
	
	stateName[3]					= "PreFire";
	stateScript[3]                  = "onPreFire";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]            = 0.1;
	stateTransitionOnTimeout[3]     = "Fire";

	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "CheckFire";
	stateTimeoutValue[4]            = 0.6;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "swing";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;

	stateName[5]					= "CheckFire";
	stateTransitionOnTriggerUp[5]	= "StopFire";
	stateTransitionOnTriggerDown[5]	= "PreFire";

	
	stateName[6]                    = "StopFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.2;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		= true;
	stateSequence[6]                = "StopFire";
	stateScript[6]                 = "onStopFire";
};

function tinyManaPotionImage::onfire(%this, %obj, %slot)
{
	%currSlot = %obj.currtool;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
	
	%obj.magicEffect("glow", 300, 0, 0);
	%obj.mana += 70;
}


datablock itemdata(regularManaPotionItem)
{
	category = "Item";  // Mission editor category
	className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./jar-b-m.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Mana Potion";
	iconName = "";
	doColorShift = false;
	// colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = regularManaPotionImage;
	canDrop = true;
};

datablock shapeBaseImageData(regularManaPotionImage)
{
	// Basic Item properties
   shapeFile = "./jar-b-m.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = regularManaPotionItem;
   ammo = " ";
   projectile = "";
   projectileType = NONE;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   // colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = weaponShiftSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;
	
	stateName[3]					= "PreFire";
	stateScript[3]                  = "onPreFire";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]            = 0.1;
	stateTransitionOnTimeout[3]     = "Fire";

	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "CheckFire";
	stateTimeoutValue[4]            = 0.6;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "swing";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;

	stateName[5]					= "CheckFire";
	stateTransitionOnTriggerUp[5]	= "StopFire";
	stateTransitionOnTriggerDown[5]	= "PreFire";

	
	stateName[6]                    = "StopFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.2;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		= true;
	stateSequence[6]                = "StopFire";
	stateScript[6]                 = "onStopFire";
};

function regularManaPotionImage::onfire(%this, %obj, %slot)
{
	%currSlot = %obj.currtool;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
	
	%obj.magicEffect("glow", 300, 0, 0);
	%obj.mana += 150;
}


datablock itemdata(hugeManaPotionItem)
{
	category = "Item";  // Mission editor category
	className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./jar-b-b.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Huge Mana Potion";
	iconName = "";
	doColorShift = false;
	// colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = hugeManaPotionImage;
	canDrop = true;
};

datablock shapeBaseImageData(hugeManaPotionImage)
{
	// Basic Item properties
   shapeFile = "./jar-b-b.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = hugeManaPotionItem;
   ammo = " ";
   projectile = "";
   projectileType = NONE;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   // colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = weaponShiftSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;
	
	stateName[3]					= "PreFire";
	stateScript[3]                  = "onPreFire";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]            = 0.1;
	stateTransitionOnTimeout[3]     = "Fire";

	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "CheckFire";
	stateTimeoutValue[4]            = 0.6;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "swing";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;

	stateName[5]					= "CheckFire";
	stateTransitionOnTriggerUp[5]	= "StopFire";
	stateTransitionOnTriggerDown[5]	= "PreFire";

	
	stateName[6]                    = "StopFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.2;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		= true;
	stateSequence[6]                = "StopFire";
	stateScript[6]                 = "onStopFire";
};

function hugeManaPotionImage::onfire(%this, %obj, %slot)
{
	%currSlot = %obj.currtool;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
	
	%obj.magicEffect("glow", 300, 0, 0);
	%obj.mana += 500;
}


datablock itemdata(tinyHPPotionItem)
{
	category = "Item";  // Mission editor category
	className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./jar-r-s.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Tiny Health Potion";
	iconName = "";
	doColorShift = false;
	// colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = TinyHPPotionImage;
	canDrop = true;
};

datablock shapeBaseImageData(tinyHPPotionImage)
{
	// Basic Item properties
   shapeFile = "./jar-r-s.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = tinyHPPotionItem;
   ammo = " ";
   projectile = "";
   projectileType = NONE;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   // colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = weaponShiftSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;
	
	stateName[3]					= "PreFire";
	stateScript[3]                  = "onPreFire";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]            = 0.1;
	stateTransitionOnTimeout[3]     = "Fire";

	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "CheckFire";
	stateTimeoutValue[4]            = 0.6;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "swing";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;

	stateName[5]					= "CheckFire";
	stateTransitionOnTriggerUp[5]	= "StopFire";
	stateTransitionOnTriggerDown[5]	= "PreFire";

	
	stateName[6]                    = "StopFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.2;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		= true;
	stateSequence[6]                = "StopFire";
	stateScript[6]                 = "onStopFire";
};

function tinyHPPotionImage::onfire(%this, %obj, %slot)
{
	%currSlot = %obj.currtool;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
	
	%obj.magicEffect("heal", 300, 0, 0);
	%obj.addHealth(30);
}


datablock itemdata(regularHPPotionItem)
{
	category = "Item";  // Mission editor category
	className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./jar-r-m.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Health Potion";
	iconName = "";
	doColorShift = false;
	// colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = regularHPPotionImage;
	canDrop = true;
};

datablock shapeBaseImageData(regularHPPotionImage)
{
	// Basic Item properties
   shapeFile = "./jar-r-m.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = regularHPPotionItem;
   ammo = " ";
   projectile = "";
   projectileType = NONE;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   // colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = weaponShiftSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;
	
	stateName[3]					= "PreFire";
	stateScript[3]                  = "onPreFire";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]            = 0.1;
	stateTransitionOnTimeout[3]     = "Fire";

	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "CheckFire";
	stateTimeoutValue[4]            = 0.6;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "swing";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;

	stateName[5]					= "CheckFire";
	stateTransitionOnTriggerUp[5]	= "StopFire";
	stateTransitionOnTriggerDown[5]	= "PreFire";

	
	stateName[6]                    = "StopFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.2;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		= true;
	stateSequence[6]                = "StopFire";
	stateScript[6]                 = "onStopFire";
};

function regularHPPotionImage::onfire(%this, %obj, %slot)
{
	%currSlot = %obj.currtool;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
	
	%obj.magicEffect("heal", 300, 0, 0);
	%obj.addHealth(70);
}


datablock itemdata(hugeHPPotionItem)
{
	category = "Item";  // Mission editor category
	className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./jar-r-b.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Huge Health Potion";
	iconName = "";
	doColorShift = false;
	// colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = hugeHPPotionImage;
	canDrop = true;
};

datablock shapeBaseImageData(hugeHPPotionImage)
{
	// Basic Item properties
   shapeFile = "./jar-r-b.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = hugeHPPotionItem;
   ammo = " ";
   projectile = "";
   projectileType = NONE;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   // colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = weaponShiftSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;
	
	stateName[3]					= "PreFire";
	stateScript[3]                  = "onPreFire";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]            = 0.1;
	stateTransitionOnTimeout[3]     = "Fire";

	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "CheckFire";
	stateTimeoutValue[4]            = 0.6;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "swing";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;

	stateName[5]					= "CheckFire";
	stateTransitionOnTriggerUp[5]	= "StopFire";
	stateTransitionOnTriggerDown[5]	= "PreFire";

	
	stateName[6]                    = "StopFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.2;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		= true;
	stateSequence[6]                = "StopFire";
	stateScript[6]                 = "onStopFire";
};

function hugeHPPotionImage::onfire(%this, %obj, %slot)
{
	%currSlot = %obj.currtool;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
	
	%obj.magicEffect("heal", 300, 0, 0);
	%obj.addHealth(150);
}


datablock itemdata(tinyXPPotionItem)
{
	category = "Item";  // Mission editor category
	className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./jar-y-s.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Tiny XP Potion";
	iconName = "";
	doColorShift = false;
	// colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = tinyXPPotionImage;
	canDrop = true;
};

datablock shapeBaseImageData(tinyXPPotionImage)
{
	// Basic Item properties
   shapeFile = "./jar-y-s.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = hugeXPPotionItem;
   ammo = " ";
   projectile = "";
   projectileType = NONE;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   // colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = weaponShiftSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;
	
	stateName[3]					= "PreFire";
	stateScript[3]                  = "onPreFire";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]            = 0.1;
	stateTransitionOnTimeout[3]     = "Fire";

	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "CheckFire";
	stateTimeoutValue[4]            = 0.6;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "swing";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;

	stateName[5]					= "CheckFire";
	stateTransitionOnTriggerUp[5]	= "StopFire";
	stateTransitionOnTriggerDown[5]	= "PreFire";

	
	stateName[6]                    = "StopFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.2;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		= true;
	stateSequence[6]                = "StopFire";
	stateScript[6]                 = "onStopFire";
};

function tinyXPPotionImage::onfire(%this, %obj, %slot)
{
	%currSlot = %obj.currtool;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
	
	%obj.magicEffect("glow", 300, 0, 0);
	%obj.client.addDXP(50);
}

datablock itemdata(regularXPPotionItem)
{
	category = "Item";  // Mission editor category
	className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./jar-y-m.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "XP Potion";
	iconName = "";
	doColorShift = false;
	// colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = regularXPPotionImage;
	canDrop = true;
};

datablock shapeBaseImageData(regularXPPotionImage)
{
	// Basic Item properties
   shapeFile = "./jar-y-m.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = regularXPPotionItem;
   ammo = " ";
   projectile = "";
   projectileType = NONE;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   // colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = weaponShiftSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;
	
	stateName[3]					= "PreFire";
	stateScript[3]                  = "onPreFire";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]            = 0.1;
	stateTransitionOnTimeout[3]     = "Fire";

	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "CheckFire";
	stateTimeoutValue[4]            = 0.6;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "swing";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;

	stateName[5]					= "CheckFire";
	stateTransitionOnTriggerUp[5]	= "StopFire";
	stateTransitionOnTriggerDown[5]	= "PreFire";

	
	stateName[6]                    = "StopFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.2;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		= true;
	stateSequence[6]                = "StopFire";
	stateScript[6]                 = "onStopFire";
};

function regularXPPotionImage::onfire(%this, %obj, %slot)
{
	%currSlot = %obj.currtool;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
	
	%obj.magicEffect("glow", 300, 0, 0);
	%obj.client.addDXP(110);
}

datablock itemdata(hugeXPPotionItem)
{
	category = "Item";  // Mission editor category
	className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./jar-y-b.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Huge XP Potion";
	iconName = "";
	doColorShift = false;
	// colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = hugeXPPotionImage;
	canDrop = true;
};

datablock shapeBaseImageData(hugeXPPotionImage)
{
	// Basic Item properties
   shapeFile = "./jar-y-b.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = hugeXPPotionItem;
   ammo = " ";
   projectile = "";
   projectileType = NONE;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   // colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = weaponShiftSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;
	
	stateName[3]					= "PreFire";
	stateScript[3]                  = "onPreFire";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]            = 0.1;
	stateTransitionOnTimeout[3]     = "Fire";

	stateName[4]                    = "Fire";
	stateTransitionOnTimeout[4]     = "CheckFire";
	stateTimeoutValue[4]            = 0.6;
	stateFire[4]                    = true;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "swing";
	stateScript[4]                  = "onFire";
	stateWaitForTimeout[4]			= true;

	stateName[5]					= "CheckFire";
	stateTransitionOnTriggerUp[5]	= "StopFire";
	stateTransitionOnTriggerDown[5]	= "PreFire";

	
	stateName[6]                    = "StopFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.2;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		= true;
	stateSequence[6]                = "StopFire";
	stateScript[6]                 = "onStopFire";
};

function hugeXPPotionImage::onfire(%this, %obj, %slot)
{
	%currSlot = %obj.currtool;
	%obj.tool[%currSlot] = 0;
	%obj.weaponCount--;
	messageClient(%obj.client,'MsgItemPickup','',%currSlot,0);
	serverCmdUnUseTool(%obj.client);
	
	%obj.magicEffect("glow", 300, 0, 0);
	%obj.client.addDXP(300);
}