ForceRequiredAddOn("System_ModSpells");
ForceRequiredAddOn("Spell_Dungeons");
ForceRequiredAddOn("Brick_Dungeon");
ForceRequiredAddOn("Brick_Singlechest");
ForceRequiredAddOn("Weapon_DungeonBladePack");
ForceRequiredAddOn("Weapon_Dungeon-RareSwords");

exec("./bugs4/AI_BigBug.cs");
exec("./bugs4/AI_BigMite.cs");
exec("./bugs4/AI_BoomerBug.cs");
exec("./bugs4/AI_BugQueen.cs");
exec("./bugs4/AI_GuardBug.cs");
exec("./bugs4/AI_MiteQueen.cs");
exec("./bugs4/AI_PoisonMite.cs");
exec("./bugs4/AI_SpineMite.cs");
exec("./bugs4/AI_Wasp_Blue.cs");

exec("./bugs2/Ai_Cicada.cs");
// exec("./bugs2/Ai_Dragonfly.cs");
exec("./bugs2/Ai_Earwig.cs");
// exec("./bugs2/Ai_Firefly.cs");
exec("./bugs2/Ai_Mantis.cs");
exec("./bugs1/Ai_Scorpion.cs");

exec("./potions/potions.cs");

function reloadDungeons()
{
	setmodpaths(getmodpaths());
	exec("add-ons/server_dungeons/server.cs");
}

$item::popTime = 60000;

// new scriptObject(DungeonMasterClient)
// {
	// isAdmin = 1;
	// isSuperAdmin = 1;

	// brickGroup = 0;
	// bl_id = 777;
	// name = "DungeonMaster";
// };

// function dungeonMasterClient::getBLID(%this)
// {
	// return %this.BL_ID;
// }

datablock fxDtsBrickData(altarBrickData)
{
	brickFile = "./altar.blb";
	category = "Special";
	subCategory = "Misc";
	uiName = "Book Altar";
	iconName = "";
};

datablock triggerData(dungeonRoomTrigger)
{
	tickPeriodMS = 500;
	parent = 0;
};

datablock StaticShapeData(BrickTextEmptyShape)
{
    shapefile = "base/data/shapes/empty.dts";
};

datablock StaticShapeData(demonBookShape)
{
	category = "Shapes";
	shapeFile = "./book.dts";
};

datablock TSShapeConstructor(DemonBookDts)
{
   baseShape = "./book.dts";
   sequence0 = "./book.dsq move";
};

datablock AudioProfile(scorePickupSound)
{
   filename    = "./pickup.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(dungeonLevelupSound)
{
   filename    = "add-ons/Gamemode_Rampage/powerup.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(dungeonChargeSound)
{
   filename    = "./energize.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(dungeonContractSound)
{
	filename 	= "./contract.wav";
	description	= AudioDefault3d;
	preload	= "true";
};

datablock AudioProfile(dungeonCongratSound)
{
	filename 	= "./congrat.wav";
	description	= AudioDefault3d;
	preload	= "true";
};

datablock AudioProfile(dungeonShadeSound)
{
	filename 	= "./shade.wav";
	description	= AudioDefault3d;
	preload	= "true";
};

datablock AudioProfile(dungeonHealSound)
{
	filename 	= "./Heal.wav";
	description	= AudioDefault3d;
	preload	= "true";
};

datablock AudioProfile(dungeonPulseSound)
{
	filename 	= "./pulse.wav";
	description	= AudioDefault3d;
	preload	= "true";
};

datablock AudioProfile(dungeonDoomGuardSound)
{
	filename 	= "./doomGuard.wav";
	description	= AudioDefault3d;
	preload	= "true";
};

datablock ParticleData(PVPSkullParticle)
{
	textureName          = "./pvpskull.png";
	dragCoefficient      = 0.0;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.0;
	windCoefficient      = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 10;
	lifetimeVarianceMS   = 0;
	spinSpeed     = 0;
	spinRandomMin = -0.0;
	spinRandomMax =  0.0;
	useInvAlpha   = false;

	colors[0]	= "0.1 0.1 0.1 1";
	colors[1]	= "0.1 0.1 0.1 1";
	colors[2]	= "0.1 0.1 0.1 0";

	sizes[0]	= 4.0;
	sizes[1]	= 4.0;
	sizes[2]	= 4.0;

	times[0]	= 0.0;
	times[1]	= 0.8;
	times[2]	= 1.0;
};
datablock ParticleEmitterData(PVPSkullEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0.0;
   ejectionVelocity = 0.0;
   ejectionOffset   = 0.0;
   velocityVariance = 0.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 0;
   overrideAdvance = false;
   particles = "PVPSkullParticle";

   useEmitterColors = false;

   uiName = "Skull";
};

datablock ShapeBaseImageData(PVPSkullImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = 6;

	stateName[0]				= "Ready";
	stateTransitionOnTimeout[0]		= "FireA";
	stateTimeoutValue[0]			= 0.01;

	stateName[1]				= "FireA";
	stateTransitionOnTimeout[1]		= "Ready";
	stateWaitForTimeout[1]			= True;
	stateTimeoutValue[1]			= 0.300;
	stateEmitter[1]				= PVPSkullEmitter;
	stateEmitterTime[1]			= 0.350;
};

// AI
datablock playerData(DungeonBaddyArmor : PlayerStandardArmor)
{
	maxDamage = 5000;
	maxForwardSpeed = 7;
	uiname = "";
};

datablock playerData(DungeonBaddySlowArmor : PlayerStandardArmor)
{
	maxDamage = 5000;
	maxForwardSpeed = 4;
	uiname = "";
};

datablock playerData(DungeonBaddyFastArmor : PlayerStandardArmor)
{
	maxDamage = 5000;
	maxForwardSpeed = 12;
	uiname = "";
};


//LEVELS

datablock playerData(dungeonPlayerLevelOne : PlayerStandardArmor)
{
	maxForwardSpeed = 7;
	jumpForce = 700;
	uiname = "";
	maxTools = 4;
	maxWeapons = 4;
	canJet = 0;
};

datablock playerData(dungeonPlayerLevelTwo : PlayerStandardArmor)
{
	maxForwardSpeed = 8;
	jumpForce = 700;
	uiname = "";
	maxTools = 5;
	maxWeapons = 5;
	canJet = 0;
};

datablock playerData(dungeonPlayerLevelThree : PlayerStandardArmor)
{
	maxForwardSpeed = 9;
	jumpForce = 700;
	uiname = "";
	maxTools = 5;
	maxWeapons = 5;
	canJet = 0;
};

datablock playerData(dungeonPlayerLevelFour : PlayerStandardArmor)
{
	maxForwardSpeed = 10;
	jumpForce = 750;
	uiname = "";
	maxTools = 6;
	maxWeapons = 6;
	canJet = 0;
};

datablock playerData(dungeonPlayerLevelFive : PlayerStandardArmor)
{
	maxForwardSpeed = 11;
	jumpForce = 800;
	uiname = "";
	maxTools = 6;
	maxWeapons = 6;
	canJet = 0;
};

datablock playerData(dungeonPlayerLevelSix : PlayerStandardArmor)
{
	maxForwardSpeed = 12;
	jumpForce = 850;
	uiname = "";
	maxTools = 7;
	maxWeapons = 7;
	canJet = 0;
};

datablock playerData(dungeonPlayerLevelSeven : PlayerStandardArmor)
{
	maxForwardSpeed = 13;
	jumpForce = 900;
	uiname = "";
	maxTools = 7;
	maxWeapons = 7;
	canJet = 0;
};

datablock playerData(dungeonPlayerLevelEight : PlayerStandardArmor)
{
	maxForwardSpeed = 14;
	jumpForce = 950;
	uiname = "";
	maxTools = 8;
	maxWeapons = 8;
	canJet = 0;
};

datablock playerData(dungeonPlayerLevelNine : PlayerStandardArmor)
{
	maxForwardSpeed = 15;
	jumpForce = 1000;
	uiname = "";
	maxTools = 8;
	maxWeapons = 8;
	canJet = 0;
};

datablock playerData(dungeonPlayerLevelTen : PlayerStandardArmor)
{
	maxForwardSpeed = 20;
	jumpForce = 1200;
	uiname = "";
	maxTools = 9;
	maxWeapons = 9;
	canJet = 1;
};

function serverCMDteleport(%client, %x, %y)
{
	if(!%client.dungeonCheater)
	{
		%client.chatMessage("!?");
		return;
	}
	createDungeon($dungeonMaster[%x, %y]);

	%client.player.setTransform(vectorAdd(vectorScale(%x SPC %y SPC "0", 16), "0 0 4"));
}

if($Pref::Server::DungeonCheatPassword $= "")
	$Pref::Server::DungeonCheatPassword = "password";

function servercmdEnableCheats(%client, %password)
{
	if(%password $= $pref::server::dungeonCheatPassword)
	{
		%client.dungeonCheater = 1;
		commandToClient(%client, 'messageBoxOK', "Cheater cheater pumpkin eater!", "You bastard :P");
	}
	else
		%client.chatMessage("!?");

}

function setDungeonMiniFromPlayers()
{
	%count = clientGroup.getCount();
	for(%i=0; %i<%count; %i++)
	{
		%client = clientGroup.getObject(%i);
		
		if(isObject(%client.minigame))
		{
			$dungeonMinigame = %client.minigame;
			return 1;
		}
	}
	
	return 0;
}

function serverCmdStartDungeon(%client)
{
	if(!%client.isSuperAdmin)
		return;
		
	if(!isObject(%client.minigame))
	{
		%client.chatMessage("Make a minigame!");
		return;
	}
	
	brickGroup_888888.chainDeleteAll();
	
	$dungeonMinigame = %client.minigame;
	
	if(isobject(nameToID(dungeonCleanupGroup)))
		nameToID(dungeonCleanupGroup).delete();
	
	new SimGroup(DungeonCleanupGroup){};

	
	missionCleanupGroup.add(dungeonCleanupGroup);
		
	makeAdvancedDungeonArray();
	
	%clients = clientGroup.getCount(); //GET IN HERE
	for(%i=0;%i<%clients;%i++)
	{
		%client = clientGroup.getObject(%i);
		
		if(isObject(%client.player))
			%client.player.createSpawnArea(0);
	}
	
	createDungeon($dungeonMaster[0, 0]);

	$dungeonStartTime = $sim::time;
	dungeonTimerLoop();
}

function startDungeon(%mini)
{
	if(!isObject(%mini))
	{
		if(!setDungeonMiniFromPlayers())
		{
			announce("No suitable minigame found!");
			return;
		}
	}
	else
		$dungeonMinigame = %mini;

	brickGroup_888888.chainDeleteAll();
	
	$dungeonMinigame = %client.minigame;
	
	if(isobject(nameToID(dungeonCleanupGroup)))
		nameToID(dungeonCleanupGroup).delete();
	
	new SimGroup(DungeonCleanupGroup){};

	
	missionCleanupGroup.add(dungeonCleanupGroup);
		
	makeAdvancedDungeonArray();
	
	%clients = clientGroup.getCount(); //GET IN HERE
	for(%i=0;%i<%clients;%i++)
	{
		%client = clientGroup.getObject(%i);
		
		if(isObject(%client.player))
			%client.player.createSpawnArea(0);
	}
	
	createDungeon($dungeonMaster[0, 0]);

	$dungeonStartTime = $sim::time;
	dungeonTimerLoop();
}

// function servercmdGetCoords(%client)
// {
	// %x = %client.player
	// %client.chatMessage("x:" SPC %client.
// }

function makeAdvancedDungeonArray()
{
	deleteVariables("$dungeonMaster*"); 
	
	%height = 80;
	%width = 80;
	
	%door1 = 0;
	%door2 = 0;
	%door3 = 0;
	%door4 = 0;
	
	for(%y = %height*-1; %y < %height; %y++)
	{
		for(%x = %width*-1; %x < %width; %x++)
		{
			//Find how far we are from 0
			%progress = mfloatLength(mSqrt(mPow(%x, 2) + mPow(%y, 2)), 0);
				
			if(%progress < 16)
				%level = 1;
				
			else if(%progress < 30)
				%level = 2;
				
			else if(%progress < 40)
				%level = 3;
				
			else if(%progress < 55)
				%level = 4;
				
			else if(%progress < 70)
				%level = 5;
			else
				%level = 6;


			%boss = "";
			if(getRandom(100) == 0 && %level > 1)
			{
				switch(getRandom(3))
				{
					case 0:
						%boss = waspSwarm;
					case 1:
						%boss = mantisBoss;
					case 2:
						%boss = scorpionBoss;
					case 3:
						%boss = demonBook;
				}
			}
			else if(getRandom(10) == 0 && %level < 6)
			{
				%boss = "SHOP";
			}
			else if(getRandom(500) == 0 && %level > 2)
			{
				%boss = "TREASURE";
			}

			if(%boss !$= "")
				echo(%boss SPC "AT" SPC %x SPC %y);
			
			%floorColor = 14;
			%doorColor = 36;
			%wallColor = 34;
			%roofColor = 6;
			%trophyColor = 2;
			%idolColor = 42;
			%aestheticColor = 14;
			
			if(%level == 2)
			{
				%floorColor = 44;
				%wallColor = 43;
				%roofColor = 43;
				%aestheticColor = 44;
			}
			else if(%level == 3)
			{
				%floorColor = 34;
				%wallColor = 33;
				%roofColor = 32;
				%idolColor = 34;
				%aestheticColor = 31;
			}
			else if(%level == 4)
			{
				%doorColor = 38;
				%floorColor = 37;
				%wallColor = 36;
				%roofColor = 37;
				%idolColor = 36;
			}
			else if(%level == 5)
			{
				%floorColor = 11;
				%wallColor = 0;
				%roofColor = 0;
				%idolColor = 11;
			}
			
			if(%x == 100 || %x == -100 || %y == 100 || %y == -100)
				%boss = finalBoss;

			%scriptObject = new ScriptObject()
			{
				x = %x;
				y = %y;

				door1 = %door1;
				door2 = %door2;
				door3 = %door3;
				door4 = %door4;

				floorColor = %floorColor;
				doorColor = %doorColor;
				wallColor = %wallColor;
				roofColor = %roofColor;
				trophyColor = %trophyColor;
				idolColor = %idolColor;
				aestheticColor = %aestheticColor;

				level = %level;

				boss = %boss;

				opened = false;
			};
			
			$dungeonMaster[%x, %y] = %scriptObject;
			//$dungeonMasterLevelCheck[%x, %y] = %level;

			
		}
	}
	
	for(%y = %height*-1; %y < %height; %y++)
	{
		for(%x = %width*-1; %x < %width; %x++)
		{
			for(%i = 1; %i < 5; %i++)
			{
				if(getRandom(10) > 5)
					createDungeonDoor(%x, %y, %i);
			}
		}
	}
}

function createDungeonDoor(%x, %y, %dir)
{
	%scriptObject = $dungeonMaster[%x, %y];

	
	switch(%dir)
	{
		case 1:
			$dungeonMaster[%x, %y+1].door3 = 1;
			%scriptObject.door1 = 1;
			
		case 2:
			$dungeonMaster[%x+1, %y].door4 = 1;
			%scriptObject.door2 = 1;
			
		case 3:
			$dungeonMaster[%x, %y-1].door1 = 1;
			%scriptObject.door3 = 1;
			
		case 4:
			$dungeonMaster[%x-1, %y].door2 = 1;
			%scriptObject.door4 = 1;
	}
}

function fxDtsBrick::openDungeonDoor(%this, %direction, %client)
{
	%room = %this.dungeonRoom;
	%x = firstword(%room);
	%y = getWord(%room, 1);
	
	
	switch(%direction)
	{
		case 1: 
			%y++;
			%ignore = 3;
		case 2:
			%x++;
			%ignore = 4;
		case 3:
			%y--;
			%ignore = 1;
		case 4: 
			%x--;
			%ignore = 2;
	}
	
	echo(%client.name SPC "opens door" SPC %direction SPC "to" SPC %x SPC %y);
	
	if(!isObject($dungeonmaster[%x, %y]))
	{
		announce(%client.name SPC "has won the dungeon!");
		%player = %client.player;
		%transform = %player.getTransform();

		%count = clientGroup.getCount();
		for(%i = 0; %i < %count; %i++)
		{
			%client = clientGroup.getObject(%i);
			%client.schedule(6900, instantRespawn);

			if(%client.minigame == $dungeonMinigame && !%client.player == %player)
			{
				%client.camera.setOrbitMode(%player, %player.getTransform(), 0.5, 8, 8, 1);
				%client.camera.mode = "Orbit";
				%client.setControlObject(%client.camera);
			}
		}

		schedule(7000, 0, startDungeon, $dungeonMinigame);
	}
	
	switch(%direction)
	{
		case 1:
			%direction = 3;
		case 2:
			%direction = 4;
		case 3:
			%direction = 1;
		case 4:
			%direction = 2;
	}
	
	if(!$dungeonMaster[%x, %y].opened)
	{
		CreateDungeon($dungeonMaster[%x, %y], %ignore);
	}
	else
	{
		$dungeonMaster[%x, %y].doorObject[%direction].delete();
	}
	
	%this.delete();
}

function createDungeon(%scriptObject, %ignoreDoor, %safeRoom)
{
	%x = %scriptObject.x;
	%y = %scriptObject.y;
	%xy = %x SPC %y;

	if(%x $= "" || %y $= "")
	{
		return;
	}
	
	for(%i = 1; %i < 5; %i++)
	{
		%door[%i] = %scriptObject.door[%i];
	}
	
	if(%ignoreDoor !$= "")
		%door[%ignoreDoor] = -1;
		
	%floorColor = %scriptObject.floorColor;
	%doorColor = %scriptObject.doorColor;
	%wallColor = %scriptObject.wallColor;
	%roofColor = %scriptObject.roofColor;
	%trophyColor = %scriptObject.trophyColor;
	%idolColor = %scriptObject.idolColor;
	%aestheticColor = %scriptObject.aestheticColor;
	
	%level = %scriptObject.level;
	
	%boss = %scriptObject.boss;

	if(%boss $= demonBook)
	{
		%doorColor = 38;
		%floorColor = 37;
		%wallColor = 36;
		%roofColor = 37;
		%idolColor = 36;

		%skipEnv = 1;

		%demonBrick = makeDungeonBrick("0 0 1.3", altarBrickData, 37, %xy, 1);
		%demonBrick.demonBookBrick = 1;

		%shape = new StaticShape()
		{
			datablock = demonBookShape;
			position = vectorAdd(vectorScale(%xy SPC "0", 16), "0 0 2.1");
			scale = "1 1 1";
		};

		%shape.playThread(0, move);
		dungeonCleanupGroup.add(%shape);

		%audio = new AudioEmitter()
		{
			position = vectorAdd(vectorScale(%xy SPC "0", 16), "0 0 2.1");
			description = audioDefaultLooping3D;
			filename = "add-ons/music/whispers.ogg";
			type = 2;
			volume = 1;
			outsideAmbient = 1;
			referenceDistance = 5;
			maxDistance = 35;
			isLooping = 1;
			loopcount = -1;
			is3D = 1;
			coneInsideAngle = 90;
			coneOutsideAngle = 120;
			coneOutsideVolume = 0.25;
			coneVector = "0 1 0";
		};

		dungeonCleanupGroup.add(%audio);
	}
	else if(%boss $= "TREASURE")
	{
		%doorColor = 2;
		%floorColor = 34;
		%wallColor = 33;
		%roofColor = 32;

		%skipEnv = 1;
		%safeRoom = 1;

		%pos = vectorAdd(vectorScale(%xy SPC "0", 16), "0 0 2.0");

		echo("TREASURE");

		switch(getRandom(4))
		{
			case 0: %itemData = "FAISwordItem";
			case 1: %itemData = "FAFSwordItem";
			case 2: %itemData = "BAMSwordItem";
			case 3: %itemData = "WAPSwordItem";
			case 4: %itemData = "LASSwordItem";
		}
		
		%price = 5000;

		%item = new Item()
		{
			dataBlock = %itemData;
			position = %pos;
			isShopItem = true;
			price = %price;
			itemName = %itemData.uiName;
		};

		echo(%itemData SPC %price);

		%item.BL_ID = 777;
		%item.minigame = $dungeonMinigame;
		%item.spawnBrick = -1;
		%item.setVelocity("0 0 -2");
		if(!isObject(dungeonCleanupGroup))
			%item.schedulePop();
		nameToID(dungeonCleanupGroup).add(%item);

		%item.setShapeName(%itemData.uiName SPC %price SPC "gold");
		%item.setShapeNameDistance(25);
		%item.setShapeNameColor("1 1 0");

		serverPlay3D(dungeonCongratSound, %pos);
	}

	//Baseplate
	makeDungeonBrick("0 0 0.5", brick32x32fdata, %floorColor, %xy, 0);
	
	//Doors
	if(%door[1] > 0)
		%door1 = makeDungeonBrick("0 7.75 2", brick1x6x5data, %doorColor, %xy, 1, 1);
	else if(%door[1] == 0)
		makeDungeonBrick("0 7.75 2", brick1x6x5data, %wallColor, %xy, 1);
	
	if(%door[2] > 0)
		%door2 = makeDungeonBrick("7.75 0 2", brick1x6x5data, %doorColor, %xy, 0, 2);
	else if(%door[2] == 0)
		makeDungeonBrick("7.75 0 2", brick1x6x5data, %wallColor, %xy, 0);

	if(%door[3] > 0)
		%door3 = makeDungeonBrick("0 -7.75 2", brick1x6x5data, %doorColor, %xy, 1, 3);
	else if(%door[3] == 0)
		makeDungeonBrick("0 -7.75 2", brick1x6x5data, %wallColor, %xy, 1);
	
	if(%door[4] > 0)
		%door4 = makeDungeonBrick("-7.75 0 2", brick1x6x5data, %doorColor, %xy, 0, 4);
	else if(%door[4] == 0)
		makeDungeonBrick("-7.75 0 2", brick1x6x5data, %wallColor, %xy, 0);

	
	//Walls
	makeDungeonBrick("7.75 4.5 2", brick1x12x5data, %wallColor, %xy, 0);
	makeDungeonBrick("7.75 -4.5 2", brick1x12x5data, %wallColor, %xy, 0);
	makeDungeonBrick("-7.75 4.5 2", brick1x12x5data, %wallColor, %xy, 0);
	makeDungeonBrick("-7.75 -4.5 2", brick1x12x5data, %wallColor, %xy, 0);
	
	makeDungeonBrick("4.5 7.75 2", brick1x12x5data, %wallColor, %xy, 1);
	makeDungeonBrick("4.5 -7.75 2", brick1x12x5data, %wallColor, %xy, 1);
	makeDungeonBrick("-4.5 7.75 2", brick1x12x5data, %wallColor, %xy, 1);
	makeDungeonBrick("-4.5 -7.75 2", brick1x12x5data, %wallColor, %xy, 1);
	
	makeDungeonBrick("7.75 4.5 5.1", brick1x12x5data, %wallColor, %xy, 0);
	makeDungeonBrick("7.75 -4.5 5.1", brick1x12x5data, %wallColor, %xy, 0);
	makeDungeonBrick("-7.75 4.5 5.1", brick1x12x5data, %wallColor, %xy, 0);
	makeDungeonBrick("-7.75 -4.5 5.1", brick1x12x5data, %wallColor, %xy, 0);
	
	makeDungeonBrick("4.5 7.75 5.1", brick1x12x5data, %wallColor, %xy, 1);
	makeDungeonBrick("4.5 -7.75 5.1", brick1x12x5data, %wallColor, %xy, 1);
	makeDungeonBrick("-4.5 7.75 5.1", brick1x12x5data, %wallColor, %xy, 1);
	makeDungeonBrick("-4.5 -7.75 5.1", brick1x12x5data, %wallColor, %xy, 1);
	
	makeDungeonBrick("7.75 0 5.1", brick1x6x5data, %wallColor, %xy, 0);
	makeDungeonBrick("0 7.75 5.1", brick1x6x5data, %wallColor, %xy, 1);
	makeDungeonBrick("-7.75 0 5.1", brick1x6x5data, %wallColor, %xy, 0);
	makeDungeonBrick("0 -7.75 5.1", brick1x6x5data, %wallColor, %xy, 1);
	
	makeDungeonBrick("7.75 4.5 8.1", brick1x12x5data, %wallColor, %xy, 0);
	makeDungeonBrick("7.75 -4.5 8.1", brick1x12x5data, %wallColor, %xy, 0);
	makeDungeonBrick("-7.75 4.5 8.1", brick1x12x5data, %wallColor, %xy, 0);
	makeDungeonBrick("-7.75 -4.5 8.1", brick1x12x5data, %wallColor, %xy, 0);
	
	makeDungeonBrick("4.5 7.75 8.1", brick1x12x5data, %wallColor, %xy, 1);
	makeDungeonBrick("4.5 -7.75 8.1", brick1x12x5data, %wallColor, %xy, 1);
	makeDungeonBrick("-4.5 7.75 8.1", brick1x12x5data, %wallColor, %xy, 1);
	makeDungeonBrick("-4.5 -7.75 8.1", brick1x12x5data, %wallColor, %xy, 1);
	
	makeDungeonBrick("7.75 0 8.1", brick1x6x5data, %wallColor, %xy, 0);
	makeDungeonBrick("0 7.75 8.1", brick1x6x5data, %wallColor, %xy, 1);
	makeDungeonBrick("-7.75 0 8.1", brick1x6x5data, %wallColor, %xy, 0);
	makeDungeonBrick("0 -7.75 8.1", brick1x6x5data, %wallColor, %xy, 1);
	
	//roof
	makeDungeonBrick("0 0 9.7", brick32x32fdata, %roofColor, %xy, 0);
	
	if(%level == 1 && !%skipEnv)
	{
		for(%i = 0; %i < 25; %i++)
		{
			%randomx = 1.5 * getRandom(-3, 3);
			%randomy = 1.5 * getRandom(-3, 3);
			
			%brick = makeDungeonBrick(0.75 + %randomx SPC 0.75 + %randomy SPC "0.7", brick3x3fGrassData, %aestheticColor, %xy, getRandom(0,3));
			%brick.setColliding(0);
		}
	}
	
	else if(%level == 2 && !%skipEnv)
	{
		for(%i = 0; %i < 15; %i++)
		{
			%randomx = 1.5 * getRandom(-3, 3);
			%randomy = 1.5 * getRandom(-3, 3);
			
			switch(getRandom(0,4))
			{
				case 0:
					makeDungeonBrick(0.75 + %randomx SPC 0.75 + %randomy SPC "1.5", brick3x3x9SpikesData, %aestheticColor, %xy, 0);
				case 1:
					makeDungeonBrick(0.75 + %randomx SPC 0.75 + %randomy SPC "1.5", brick3x3x9SpikesData, %aestheticColor, %xy, 0);
				case 2:
					makeDungeonBrick(0.75 + %randomx SPC 0.75 + %randomy SPC "8.7", brick3x3x9SpikesInvData, %aestheticColor, %xy, 0);
				case 3:
					makeDungeonBrick(0.75 + %randomx SPC 0.75 + %randomy SPC "8.7", brick3x3x9SpikesInvData, %aestheticColor, %xy, 0);
				case 4:
					makeDungeonBrick(0.75 + %randomx SPC 0.75 + %randomy SPC "1.5", brick3x3x9Spikes2Data, %aestheticColor, %xy, 0);
			}
		}
	}
	
	else if(%level == 3 && !%skipEnv)
	{
		if(getRandom(0,1))
			makeDungeonBrick("7 3 3.6", brick2x2x30PedestalData, %aestheticColor, %xy, 0);
		else
		{
			makeDungeonBrick("7 3 2.5", brick2x2x3StatueData, %idolColor, %xy, 0);
			makeDungeonBrick("7 3 1.1", brick2x2x5PedestalData, %aestheticColor, %xy, 0);
		}
		
		if(getRandom(0,1))
			makeDungeonBrick("7 -3 3.6", brick2x2x30PedestalData, %aestheticColor, %xy, 0);
		else
		{
			makeDungeonBrick("7 -3 2.5", brick2x2x3StatueData, %idolColor, %xy, 0);
			makeDungeonBrick("7 -3 1.1", brick2x2x5PedestalData, %aestheticColor, %xy, 0);
		}
		
		if(getRandom(0,1))
			makeDungeonBrick("-7 3 3.6", brick2x2x30PedestalData, %aestheticColor, %xy, 2);
		else
		{
			makeDungeonBrick("-7 3 2.5", brick2x2x3StatueData, %idolColor, %xy, 2);
			makeDungeonBrick("-7 3 1.1", brick2x2x5PedestalData, %aestheticColor, %xy, 2);
		}
		
		if(getRandom(0,1))
			makeDungeonBrick("-7 -3 3.6", brick2x2x30PedestalData, %aestheticColor, %xy, 2);
		else
		{
			makeDungeonBrick("-7 -3 2.5", brick2x2x3StatueData, %idolColor, %xy, 2);
			makeDungeonBrick("-7 -3 1.1", brick2x2x5PedestalData, %aestheticColor, %xy, 2);
		}
		
		if(getRandom(0,1))
			makeDungeonBrick("3 7 3.6", brick2x2x30PedestalData, %aestheticColor, %xy, 3);
		else
		{
			makeDungeonBrick("3 7 2.5", brick2x2x3StatueData, %idolColor, %xy, 3);
			makeDungeonBrick("3 7 1.1", brick2x2x5PedestalData, %aestheticColor, %xy, 3);
		}

		if(getRandom(0,1))
			makeDungeonBrick("-3 7 3.6", brick2x2x30PedestalData, %aestheticColor, %xy, 3);
		else
		{
			makeDungeonBrick("-3 7 2.5", brick2x2x3StatueData, %idolColor, %xy, 3);
			makeDungeonBrick("-3 7 1.1", brick2x2x5PedestalData, %aestheticColor, %xy, 3);
		}
		
		if(getRandom(0,1))
			makeDungeonBrick("3 -7 3.6", brick2x2x30PedestalData, %aestheticColor, %xy, 1);
		else
		{
			makeDungeonBrick("3 -7 2.5", brick2x2x3StatueData, %idolColor, %xy, 1);
			makeDungeonBrick("3 -7 1.1", brick2x2x5PedestalData, %aestheticColor, %xy, 1);
		}
		
		if(getRandom(0,1))
			makeDungeonBrick("-3 -7 3.6", brick2x2x30PedestalData, %aestheticColor, %xy, 1);
		else
		{
			makeDungeonBrick("-3 -7 2.5", brick2x2x3StatueData, %idolColor, %xy, 1);
			makeDungeonBrick("-3 -7 1.1", brick2x2x5PedestalData, %aestheticColor, %xy, 1);
		}
	}
	
	if(%level == 5 && !%skipEnv)
	{
		for(%randomx = -2; %randomx <= 2; %randomx++)
		{
			for(%randomy = -2; %randomy <= 2; %randomy++)
			{
				%brick = makeDungeonBrick(0 + %randomx*3 SPC 0 + %randomy*3 SPC "0.7", nameToID("brick6x6fVein" @ getRandom(1, 9) @ "Data"), %floorColor, %xy, getRandom(0,3));
				%brick.setColliding(0);
			}
		}
	}
	
	if(getRandom(0,3) == 3 && !%skipEnv)
	{
		%height = 1.1;
		
		if(%level == 5)
			%height = 1.3;

		switch(getRandom(0,3))
		{
			case 0:
				makeDungeonBrick("6.5 6.5" SPC %height, brickSingleChestData, %idolColor, %xy, getRandom(0,3));

			case 1:
				makeDungeonBrick("6.5 -6.5" SPC %height, brickSingleChestData, %idolColor, %xy, getRandom(0,3));

			case 2:
				makeDungeonBrick("-6.5 6.5" SPC %height, brickSingleChestData, %idolColor, %xy, getRandom(0,3));

			case 3:
				makeDungeonBrick("-6.5 -6.5" SPC %height, brickSingleChestData, %idolColor, %xy, getRandom(0,3));
		}
	}

	if(%boss !$= "")
	{
		echo(%boss);
		switch$(%boss)
		{
			case "SHOP":
				%numShopItems = getRandom(3, 10);
				%shopValue = getRandom() + 1;
				for(%i = 0; %i < %numShopItems; %i++)
				{
					%shopItem = getShopItem(%level);
					%itemData = getField(%shopItem, 0);
					
					if(!isObject(%itemData))
						continue;
					
					%price = mFloatLength(getField(%shopItem, 1) * %shopValue, 0);
					%pos = vectorAdd(vectorScale(%xy SPC "0", 16), getRandom(-60, 60)/10 SPC getRandom(-60, 60)/10 SPC "4.0");

					echo(%shopItem TAB %pos);

					%item = new Item()
					{
						dataBlock = %itemData;
						position = %pos;
						isShopItem = true;
						price = %price;
						itemName = %itemData.uiName;
					};

					%item.BL_ID = 777;
					%item.minigame = $dungeonMinigame;
					%item.spawnBrick = -1;
					%item.setVelocity("0 0 -2");
					if(!isObject(dungeonCleanupGroup))
						%item.schedulePop();
					nameToID(dungeonCleanupGroup).add(%item);

					%item.setShapeName(%itemData.uiName SPC %price SPC "gold");
					%item.setShapeNameDistance(15);
					%item.setShapeNameColor("0 1 0");
				}

				%safeRoom = 1;

			case "scorpionBoss":
				makeDungeonEnemy(%xy, 11, %level, 250, 300*%level, 3);
				makeDungeonEnemy(%xy, 9, %level, 35, 50, 2);
				%safeRoom = 1;

			case "mantisBoss":
				makeDungeonEnemy(%xy, 12, %level, 250, 400*%level, 3);
				makeDungeonEnemy(%xy, 9, %level, 35, 50, 2);
				%safeRoom = 1;

			case "waspSwarm":
				for(%i = 0; %i < %level*2; %i++)
				{
					makeDungeonEnemy(%xy, 9, %level, 35, 50, 2);
				}
				%safeRoom = 1;
		}
	}
	
	else if(getRandom(0,20) == 15 && %level > 2)
	{
		%height = 1.7;
		
		if(%level == 4 || %level == 3)
			%height = 1.5;
		
		%brick = makeDungeonBrick("0 0" SPC %height, brick2x2x3CrystalPedestalAData, %idolColor, %xy, 0);
		
		%pedestalChance = getRandom(2);

		switch(%pedestalChance)
		{
			case 0:
				%brick.setEmitter(magic_goldSparkleEmitter);
				%brick.pedestalType = 1;
				echo("Pedestal Created - CASE:" SPC %pedestalChance SPC "- Pedestal Created.");
				
			case 1:
				%brick.setEmitter(magic_azureSparkleEmitter);
				%brick.pedestalType = 2;
				echo("Pedestal Created - CASE:" SPC %pedestalChance SPC "- Pedestal Created.");
				
			case 2:
				%brick.setEmitter(magic_pinkSparkleEmitter);
				%brick.pedestalType = 3;
				echo("Pedestal Created - CASE:" SPC %pedestalChance SPC "- Pedestal Created.");
				
			default:
				%brick.setDatablock(brick2x2x3CrystalPedestalBData);
				%brick.setEmitter(FridgeFog1Emitter);
				echo("Pedestal Created - CASE:" SPC %pedestalChance SPC "- Pedestal was not created!");
		}
	}
	
	if(!%safeRoom)
	{
		for(%i = getRandom(0, %level); %i > 0; %i--)
		{
			%gold = getRandom(0, 10*%level);
			if(!getRandom(0,25))
				%gold += 50*%level;

			%lootTier = getRandom(4, %level);
			%health = getRandom(20, 50*%level);

			switch(%level)
			{
				case 1:
					%type = getRandom(0, 2);
				case 2:
					%type = getRandom(0, 4);
				case 3:
					%type = getRandom(0, 6);
				case 4:
					%type = getRandom(2, 7);
				case 5:
					%type = getRandom(3, 8);
				case 6:
					%type = getRandom(5, 10);
			}

			makeDungeonEnemy(%xy, %type, %level, %health, %gold, getRandom(30, 40)/10);
			if(%boss > 0)
				break;
		}
	}

	%blocker = makeDungeonBrick("0 0 3.6", brick30x30DoorBlockerData, 0, %xy, 0, 4, %level); //Door blocker
	%blocker.setColliding(0);
	%blocker.setRayCasting(0);

	for(%i = 1; %i < 5; %i++)
	{
		%scriptObject.doorObject[%i] = %door[%i];
	}

	%scriptObject.doorBlocker = %blocker;
	%scriptObject.opened = true;
}

function makeDungeonBrick(%position, %data, %color, %xy, %rot, %door, %level)
{
	if(%data $= brick32x32fdata)
		%baseplate = 1;
	else
		%baseplate = 0;
	
	%brick = new fxDTSBrick()
	{
		// client = DungeonMasterClient;
		datablock = %data;
		position = vectorAdd(%position,vectorScale(%xy SPC "0",16));
		rotation = rotationFromAngleID(%rot);
		colorID = %color;
		angleID = %rot;
		colorfxID = 0;
		shapefxID = 0;
		isPlanted = 1;
		isBaseplate = %baseplate;
		stackBL_ID = 888888;
		dungeonRoom = %xy;
		level = %level;
	};
	
	// echo(%brick);
	%brick.setTrusted(1);
	%brick.plant();
	
	
	nameToID("brickGroup_888888").add(%brick);
	
	
	if(%door > 0 && %door <= 4)
	{
		%brick.dungeonDoor = %door;
	}
	
	return %brick;
}

function player::createSpawnArea(%this, %tries)
{
	if(%tries > 5)
	{
		%this.setTransform(getRandom(-3, 3) SPC getRandom(-3, 3) SPC "1");
		%this.client.chatMessage("We couldn't find a suitable spawn area for you. Sorry for the inconvenience!");
		return;
	}
	%x = getRandom(-13,13);
	%y = getRandom(-13,13);
	
	if($dungeonMaster[%x, %y].opened)
	{
		%this.createSpawnArea(%tries+1);
		return;
	}
	
	createDungeon($dungeonMaster[%x, %y], 0, 1);
	%this.setTransform(vectorAdd(vectorScale(%x SPC %y SPC "0", 16), "0 0 0.7"));
}

function makeDungeonEnemy(%xy, %type, %level, %health, %gold, %spawnHeight)
{
	// Create the AI
	%bot = new AiPlayer(DungeonMonster)
	{
		position = vectorAdd(getRandom(-5, 5) SPC getRandom(-5, 5) SPC %spawnHeight*2 ,vectorScale(%xy SPC "0",16));
		datablock = PlayerStandardArmor;
		dungeonAI = true;
		minigame = $dungeonMinigame;
	};

	%bot.client = %bot;
	%bot.level = %level;
	%bot.gold = %gold;
	%bot.lootTier = %lootTier;
	%bot.lastAttackTime = $sim::time;
	%bot.setMoveSlowdown(0);
	%bot.isDungeonAI = true;

	%recolor = true;
	// Set AI datablock
	switch(%type)
	{
		case 0:
			%bot.setDataBlock(BigBug);
			%bot.AiMode = "groundBite";
			%bot.attackDamage = 5;
			%health = %level/2 * getRandom(20, 40);
			%bot.name = "Bug";
		case 1:
			%bot.setDataBlock(BigBug);
			%bot.AiMode = "groundBite";
			%bot.attackDamage = 10;
			%health = %level/2 * getRandom(30, 40);
			%bot.name = "Bug";
		case 2:
			%bot.setDataBlock(BoomerBug);
			%bot.AiMode = "groundBite";
			%bot.attackDamage = 20;
			%health = %level/2 * getRandom(30, 50);
			%bot.name = "Bug";
		case 3:
			%bot.setDataBlock(GuardBug);
			%bot.AiMode = "groundBite";
			%bot.attackDamage = 7;
			%health = %level/2 * getRandom(75, 100);
			%bot.name = "Guard Bug"; 
		case 4:
			%bot.setDataBlock(BugQueenArmor);
			%bot.AiMode = "groundRanged";
			%bot.attackDamage = 10;
			%health = %level/2 * getRandom(30, 100);
			%bot.name = "Bug Queen";
		case 5:
			%bot.setDataBlock(BigMiteArmor);
			%bot.AiMode = "groundBite";
			%bot.attackDamage = 25;
			%health = %level/2 * getRandom(30, 50);
			%bot.name = "Mite";
		case 6:
			%bot.setDataBlock(SpineMiteArmor);
			%bot.AiMode = "groundRangedAgro";
			%bot.attackDamage = 35;
			%health = %level/2 * getRandom(50, 80);
			%bot.name = "Mite Torcher";
		case 7:
			%bot.setDataBlock(PoisonMiteArmor);
			%bot.AiMode = "groundBite";
			%bot.attackDamage = 10;
			%health = %level/2 * getRandom(60, 80);
			%bot.name = "Spined Mite";
		case 8:
			%bot.setDataBlock(MiteQueenArmor);
			%bot.AiMode = "groundBite";
			%bot.attackDamage = 50;
			%health = %level/2 * getRandom(60, 100);
			%bot.name = "Mite Queen";
		case 9:
			%bot.setDataBlock(BlueWaspArmor);
			%bot.AiMode = "flyingBite";
			%bot.attackDamage = 30;
			%bot.setScale("0.5 0.5 0.5");
			%health = %level/2 * getRandom(7, 15);
			%bot.name = "Blue Wasp";
			%recolor = false;
		case 10:
			%bot.setDataBlock(Cicda);
			%bot.AiMode = "flyingBite";
			%bot.attackDamage = 10;
			%bot.setScale("0.7 0.7 0.7");
			%health = %level/2 * getRandom(20, 40);
			%bot.name = "Cicada";
		case 11:
			%bot.setDataBlock(ScorpionHoleBot);
			%bot.AiMode = "scorpionBoss";
			%bot.attackDamage = 75;
			%bot.setScale("0.7 0.7 0.7");
			%bot.name = "Scorpion Boss";
			%health = 150 * %level;
			%bot.setShapeName(%bot.name, 8564862);
			%bot.setShapeNameColor("1 0 0");
			%bot.setShapeNameDistance(50);

		case 12:
			%bot.setDataBlock(mantisZombie);
			%bot.AiMode = "flyingBite";
			%bot.attackDamage = 60;
			%bot.setScale("0.6 0.6 0.6");
			%bot.name = "Mantis Boss";
			%bot.health = 100 * %level;
			%bot.setShapeName(%bot.name, 8564862);
			%bot.setShapeNameColor("1 0 0");
			%bot.setShapeNameDistance(50);
			%recolor = 0;

	}

	%bot.setMaximumHealth(%health);

	// Set AI colors
	if(%recolor)
	{
		switch(%level)
		{
			case 1:
				%color = getRandom(3, 7)/10;
				%bot.setNodeColor("ALL", %color SPC %color SPC %color SPC "1");
				
			case 2:
				%color = getRandom(9, 7)/10 SPC getRandom(3, 5)/10 SPC getRandom(0, 2)/10;
				%bot.setNodeColor("ALL", %color SPC "1");
				
			case 3:
				%color = getRandom(8, 10)/10;
				%bot.setNodeColor("ALL", %color SPC %color SPC %color SPC "1");
				
			case 4:
				%color = getRandom(1, 4)/10;
				%bot.setNodeColor("ALL", %color SPC %color SPC %color SPC "1");
				
			case 5:
				%bot.setNodeColor("ALL", "0.7 0.1 0.1 1");
				
			// case 6:
			// 	%bot.setNodeColor("ALL", "0.1 0.1 0.1 0.8");
		}
	}

	switch$(%bot.AiMode)
	{
		case "groundBite":
			%bot.thinkSchedule = schedule(750, %bot, dungeonBotThinkLoopGB, %bot);

		case "flyingBite":
			%bot.thinkSchedule = schedule(750, %bot, dungeonBotThinkLoopFB, %bot);

		case "groundRanged":
			%bot.thinkSchedule = schedule(750, %bot, dungeonBotThinkLoopGR, %bot);

		case "groundRangedAgro":
			%bot.thinkSchedule = schedule(750, %bot, dungeonBotThinkLoopGRA, %bot);

		case "scorpionBoss":
			%bot.thinkSchedule = schedule(250, %bot, dungeonBotThinkLoopScorpionBoss, %bot);

		case "mantisBoss":
			%bot.thinkSchedule = schedule(250, %bot, dungeonBotThinkLoopMantiBoss, %bot);

		default:
			%bot.delete();
	}

	dungeonCleanupGroup.add(%bot);

	return %bot;
}

function dungeonBotThinkLoopGB(%bot)
{
	if(isObject(%bot.target))
	{
		if(isObstruction(%bot.target.getHackPosition(), %bot))
		{
			%bot.target = "";
			%bot.setMoveObject(0);
			%bot.stop();
			%bot.setAimObject(0);
			%bot.thinkSchedule = schedule(250, %bot, dungeonBotThinkLoopGB, %bot);
			return;
		}

		else
		{			
			if(vectorDist(%bot.getPosition(), %bot.target.getPosition()) < 2)
			{
				%bot.setJumping(1);
				%bot.schedule(200, setJumping, 0);
			}
			%bot.thinkSchedule = schedule(250, %bot, dungeonBotThinkLoopGB, %bot);
			return;
		}
	}

	else
	{
		initContainerRadiusSearch(%bot.getPosition(), 35, $TypeMasks::PlayerObjectType);
	
		while(1)
		{
			%search = containerSearchNext();
			
			if(!%search)
				break;

			if(%search.dungeonAI)
				continue;

			if(isObstruction(%search.getHackPosition(), %bot))
			{
				continue;
			}
			
			if(!minigameCanDamage(%bot, %search))
				continue;
				
			if(isObject(%search))
			{
				%bot.target = %search;
			}
			
			break;
		}
	}

	%bot.thinkSchedule = schedule(1000, %bot, dungeonBotThinkLoopGB, %bot);

	if(!isObject(%bot.target))
	{
		return;
	}

	%bot.setMoveObject(%bot.target);
	%bot.setAimObject(%bot.target);
}

function dungeonBotThinkLoopFB(%bot)
{
	if(isObject(%bot.target))
	{
		if(isObstruction(%bot.target.getHackPosition(), %bot) || %bot.target.getState() $= "dead")
		{
			%bot.target = "";
			%bot.setMoveObject(0);
			%bot.stop();
			%bot.setAimObject(0);
			%bot.thinkSchedule = schedule(250, %bot, dungeonBotThinkLoopGB, %bot);
			return;
		}

		else
		{
			%bot.addVelocity("0 0 7");
			%bot.thinkSchedule = schedule(250, %bot, dungeonBotThinkLoopGB, %bot);
			return;
		}
	}

	else
	{
		initContainerRadiusSearch(%bot.getPosition(), 35, $TypeMasks::PlayerObjectType);
	
		while(1)
		{
			%search = containerSearchNext();
			
			if(!%search)
				break;

			if(%search.dungeonAI)
				continue;

			if(isObstruction(%search.getHackPosition(), %bot))
			{
				continue;
			}
			
			if(!minigameCanDamage(%bot, %search))
				continue;
				
			if(isObject(%search))
			{
				%bot.target = %search;
			}
			
			break;
		}
	}

	%bot.thinkSchedule = schedule(1000, %bot, dungeonBotThinkLoopGB, %bot);

	if(!isObject(%bot.target))
	{
		return;
	}

	%bot.setMoveObject(%bot.target);
	%bot.setAimObject(%bot.target);
	%bot.setVelocity("0 0 25");
	%bot.playThread(0, fly);
		
	if(vectorDist(%bot.target.getPosition(), %bot.getPosition()) < 3)
	{
		// %bot.setJumping(1);
		// %bot.schedule(200, setJumping, 0);
	}
}

function dungeonBotThinkRetreatFB(%bot)
{
	if(!isObject(%bot.target))
	{
		dungeonBotThinkLoopFB(%bot);
		return;
	}

	%bot.setVelocity("0 0 25");
	%bot.playThread(0, fly);
	%pos = %bot.getPosition();
	%bot.setMoveObject(0);

	for(%i = 0; %i < 20; %i++)
	{
		%x = getRandom(-5, 5);
		%y = getRandom(-5, 5);

		%loc = vectorAdd(%pos, %x SPC %y SPC "0");

		if(!isObstruction(%loc, %bot))
			break;
	}

	%bot.setMoveDestination(%loc);

	%bot.thinkSchedule = schedule(1500, %bot, dungeonBotThinkLoopFB, %bot);
	%bot.schedule(900, setMoveDestination, 0);
	%bot.schedule(900, setMoveObject, %bot.target);
}

function dungeonBotThinkLoopGR(%bot)
{
	if(isObject(%bot.target))
	{
		if(isObstruction(%bot.target.getHackPosition(), %bot))
		{
			%bot.target = "";
			%bot.setAimObject(0);
			%bot.thinkSchedule = schedule(250, %bot, dungeonBotThinkLoopGR, %bot);
			return;
		}

		else
		{
			if(vectorDist(%bot.target.getPosition(), %bot.getPosition()) < 6)
			{
				cancel(%bot.thinkSchedule);
				dungeonBotThinkRetreatGR(%bot);
				return;
			}
			%bot.thinkSchedule = schedule(1000, %bot, dungeonBotThinkLoopGR, %bot);
			%bot.botAttack();
			return;
		}
	}

	else
	{
		initContainerRadiusSearch(%bot.getPosition(), 35, $TypeMasks::PlayerObjectType);
	
		while(1)
		{
			%search = containerSearchNext();
			
			if(!%search)
				break;

			if(%search.dungeonAI)
				continue;

			if(isObstruction(%search.getHackPosition(), %bot))
			{
				continue;
			}
			
			if(!minigameCanDamage(%bot, %search))
				continue;
				
			if(isObject(%search))
			{
				%bot.target = %search;
			}
			
			break;
		}
	}

	%bot.thinkSchedule = schedule(1000, %bot, dungeonBotThinkLoopGR, %bot);

	if(!isObject(%bot.target))
	{
		return;
	}

	%bot.setAimObject(%bot.target);
}

function dungeonBotThinkRetreatGR(%bot)
{
	if(!isObject(%bot.target) || %bot.target.getState() $= "dead")
	{
		%bot.thinkSchedule = schedule(500, %bot, dungeonBotThinkLoopGR, %bot);
		return;
	}

	%pos = %bot.getPosition();
	%bot.setMoveObject(0);

	if(!%bot.awayDist)
		%bot.awayDist = vectorDist(%bot, %bot.target);

	for(%i = 0; %i < 20; %i++)
	{
		%x = getRandom(-10, 10);
		%y = getRandom(-10, 10);

		%loc = vectorAdd(%pos, %x SPC %y SPC "0");

		if(!isObstruction(%loc, %bot) && vectorDist(%bot, %bot.target) > %bot.awayDist)
			break;
	}

	%bot.setMoveDestination(%loc);

	%bot.thinkSchedule = schedule(1500, %bot, dungeonBotThinkLoopGR, %bot);
}

function dungeonBotThinkLoopGRA(%bot)
{
	if(isObject(%bot.target))
	{
		if(isObstruction(%bot.target.getHackPosition(), %bot))
		{
			%bot.target = "";
			%bot.setAimObject(0);
			%bot.thinkSchedule = schedule(250, %bot, dungeonBotThinkLoopGRA, %bot);
			return;
		}

		else
		{
			if(vectorDist(%bot.target.getPosition(), %bot.getPosition()) < 6)
			{
				cancel(%bot.thinkSchedule);
				dungeonBotThinkLoopGB(%bot);
				return;
			}
			%bot.thinkSchedule = schedule(1000, %bot, dungeonBotThinkLoopGRA, %bot);
			%bot.botAttack();
			return;
		}
	}

	else
	{
		initContainerRadiusSearch(%bot.getPosition(), 35, $TypeMasks::PlayerObjectType);
	
		while(1)
		{
			%search = containerSearchNext();
			
			if(!%search)
				break;

			if(%search.dungeonAI)
				continue;

			if(isObstruction(%search.getHackPosition(), %bot))
			{
				continue;
			}
			
			if(!minigameCanDamage(%bot, %search))
				continue;
				
			if(isObject(%search))
			{
				%bot.target = %search;
			}
			
			break;
		}
	}

	%bot.thinkSchedule = schedule(1000, %bot, dungeonBotThinkLoopGRA, %bot);

	if(!isObject(%bot.target))
	{
		return;
	}

	%bot.setAimObject(%bot.target);
}

function aiPlayer::botAttack(%this)
{
	if(%this.AiMode $= "groundRanged" || %this.AiMode $= "groundRangedAgro")
	{
		%this.playThread(2, activate);

		%targetPos = %this.target.getPosition();
		%pos = %this.getEyePoint();
		%upForce = 5 + getWord(%targetPos, 2) - getWord(%pos, 2);

		%proj = new Projectile()
		{
			sourceObject = %this;
			initialPosition = %pos;
			initialVelocity = calculateThrownVector(%pos, %this.target.getPosition(), %upForce, 1);
			sourceSlot = 0;
			datablock = magic_fireball;
			client = %this;
		};
		
		%proj.setScale("0.5 0.5 0.5");

		dungeonCleanupGroup.add(%proj);
	}
}

function dungeonBotThinkLoopScorpionBoss(%bot)
{
	if(isObject(%bot.target))
	{
		if(isObstruction(%bot.target.getHackPosition(), %bot))
		{
			%bot.target = "";
			%bot.setMoveObject(0);
			%bot.stop();
			%bot.setAimObject(0);
			%bot.thinkSchedule = schedule(250, %bot, dungeonBotThinkLoopScorpionBoss, %bot);
			return;
		}

		else
		{			
			if(vectorDist(%bot.getPosition(), %bot.target.getPosition()) > 3 && getRandom(30) == 1)
			{
				%bot.stingReady = 1;
				%bot.playThread(3, stingReady);
			}
			%bot.stop();
			%bot.setMoveObject(%bot.target);
			%bot.thinkSchedule = schedule(250, %bot, dungeonBotThinkLoopScorpionBoss, %bot);
			return;
		}
	}

	else
	{
		initContainerRadiusSearch(%bot.getPosition(), 35, $TypeMasks::PlayerObjectType);
	
		while(1)
		{
			%search = containerSearchNext();
			
			if(!%search)
				break;

			if(%search.dungeonAI)
				continue;

			if(isObstruction(%search.getHackPosition(), %bot))
			{
				continue;
			}
			
			if(!minigameCanDamage(%bot, %search))
				continue;
				
			if(isObject(%search))
			{
				%bot.target = %search;
			}
			
			break;
		}
	}

	%bot.thinkSchedule = schedule(100, %bot, dungeonBotThinkLoopScorpionBoss, %bot);

	if(!isObject(%bot.target))
	{
		return;
	}

	%bot.setMoveObject(%bot.target);
	%bot.setAimObject(%bot.target);
}

function dungeonBotThinkRetreatScorpionBoss(%bot)
{
	// if(!isObject(%bot.target) || %bot.target.getState() $= "dead")
	// {
	// 	dungeonBotThinkLoopScorpionBoss(%bot);
	// 	return;
	// }

	%pos = %bot.getPosition();
	%bot.setMoveObject(0);

	for(%i = 0; %i < 20; %i++)
	{
		%x = getRandom(-15, 15);
		%y = getRandom(-15, 15);

		%loc = vectorAdd(%pos, %x SPC %y SPC "0");

		if(!isObstruction(%loc, %bot) && vectorDist(%bot, %bot.target) > %bot.awayDist)
			break;
	}

	%bot.setMoveDestination(%loc);
}

// function dungeonBotThinkLoop(%bot)
// {
// 	if(isObject(%bot.target))
// 	{
// 		if(%bot.target.isHidden)
// 		{
// 			%bot.client.thinkSchedule = schedule(1000, %bot, dungeonBotThinkLoop, %bot);  //Dip seagulls in pink vinyl
// 			return;	
// 		}
// 		if(isObstruction(%bot.target.getHackPosition(), %bot))
// 		{
// 			%bot.target = "";
// 			%bot.setMoveObject(0);
// 			%bot.stop();
// 			%bot.setImageTrigger(0, 0);
// 			%bot.setAimObject(0);
// 			// %bot.schedule(200, smoothWander);
// 			%bot.client.thinkSchedule = schedule(1000, %bot, dungeonBotThinkLoop, %bot);
// 			return;
// 		}
			
// 		else
// 		{
// 			%bot.client.thinkSchedule = schedule(1000, %bot, dungeonBotThinkLoop, %bot);  //Dip seagulls in pink vinyl
// 			return;
// 		}
// 	}
	
// 	%bot.setImageTrigger(0, 0);
	
// 	%clients = clientGroup.getCount();
// 	for(%i = 0; %i < %clients; %i++)
// 	{
// 		%client = clientGroup.getObject(%i);
		
// 		// if(!%client.minigame.isTheDungeonOfDoomyDoom)
// 			// continue;
			
// 		if(!isObject(%client.player))
// 			continue;
			
// 		if(isObstruction(%client.player.getHackPosition(), %bot))
// 			continue;
			
// 		if(%client.player.isHidden)
// 			continue;
		
// 		%bot.target = %client.player;

// 		break;
		
// 	}
	
// 	if(isObject(%bot.target))
// 	{
// 		%bot.setMoveObject(%client.player);
// 		%bot.setAimObject(%client.player);
		
// 		if(vectorDist(%bot.target.getPosition(), %bot.getPosition()) < 3)
// 			%bot.setImageTrigger(0, 1);
// 		else
// 			%bot.setImageTrigger(0, 1);

// 	}
	
// 	// if(%target $= "")
// 	// {
// 		// %bot.smoothWander();
// 	// }
	
// 	%bot.client.thinkSchedule = schedule(1000, %bot, dungeonBotThinkLoop, %bot);
// }

function getShopItem(%level)
{
	%luck = getRandom(0,50*(%level));
	
	if(%luck < 50)
	{
		switch(getRandom(5))
		{
			case 0:
				return bronzeShortSwordItem TAB 10;
			case 1: 
				return bronzeLongSwordItem TAB 40;
			case 2: 
				return bronzeBattleAxeItem TAB 30;
			case 3:
				return tinyManaPotionItem TAB 10;
			case 4:
				return tinyHPPotionItem TAB 20;
			case 5:
				return magicStaffBaseItem TAB 10;
		}
	}
	
	else if(%luck < 100)
	{
		switch(getRandom(6))
		{
			case 0:
				return ironShortSwordItem TAB 60;
			case 1: 
				return ironLongSwordItem TAB 80;
			case 2:
				return ironDaggerItem TAB 45;
			case 3: 
				return ironBattleAxeItem TAB 70;
			case 4:
				return tinyXPPotionItem TAB 30;
			case 5:
				return regularManaPotionItem TAB 40;
			case 6:
				return regularHPPotionItem TAB 60;
		}
	}
	
	else if(%luck < 150)
	{
		switch(getRandom(4))
		{
			case 0:
				return SteelShortSwordItem TAB 90;
			case 1: 
				return SteelLongSwordItem TAB 120;
			case 2:
				return SteelDaggerItem TAB 80;
			case 3: 
				return SteelBattleAxeItem TAB 100;
			case 4:
				return regularXPPotionItem TAB 90;
		}
	}
	
	else if(%luck < 200)
	{
		switch(getRandom(3))
		{
			case 0:
				return mithrilDaggerItem TAB 400;
			case 1:
				return mithrilShortSwordItem TAB 500;
			case 2:
				return hugeHPPotionItem TAB 100;
			case 3:
				return hugeManaPotionItem TAB 75;
		}
	}
	
	else if(%luck >= 200)
	{
		switch(getRandom(6))
		{
			case 0:
				return mithrilDaggerItem TAB 400;
			case 1:
				return mithrilShortSwordItem TAB 500;
			case 2:
				return mithrilBattleAxeItem TAB 700;
			case 3:
				return mithrilLongSwordItem TAB 900;
			case 4:
				return hugeHPPotionItem TAB 100;
			case 5:
				return hugeManaPotionItem TAB 75;
			case 6:
				return hugeXPPotionItem TAB 200;
		}
	}
	
	echo("Something actually went wrong in getShopItem wtf");
	return 0;
}

function getTieredItem(%luck, %level)
{
	if(!%luck)
		%luck = getRandom(0,50*(1.2*%level));
		
	%luck *= 1.2*%level;

	if(%luck < 50)
	{
		switch(getRandom(9))
		{
			case 0:
				return bronzeShortSwordItem;
			case 1: 
				return bronzeLongSwordItem;
			case 2:
				return bronzeDaggerItem;
			case 3: 
				return bronzeBattleAxeItem;
			case 4:
				return "SPELL lesserheal";
			case 5:
				return "SPELL flashfire";
			case 6:
				return "SPELL shield";
			case 7:
				return tinyManaPotionItem;
			case 8:
				return tinyHPPotionItem;
			default:
				return magicStaffBaseItem;
		}
	}
	
	else if(%luck < 100)
	{
		switch(getRandom(8))
		{
			case 0:
				return ironShortSwordItem;
			case 1: 
				return ironLongSwordItem;
			case 2:
				return ironDaggerItem;
			case 3: 
				return ironBattleAxeItem;
			case 4:
				 return "SPELL heal";
			case 5:
				return "SPELL frostshards";
			case 6:
				return tinyXPPotionItem;
			case 7:
				return regularManaPotionItem;
			case 8:
				return regularHPPotionItem;
		}
	}
	
	else if(%luck < 150)
	{
		switch(getRandom(6))
		{
			case 0:
				return SteelShortSwordItem;
			case 1: 
				return SteelLongSwordItem;
			case 2:
				return SteelDaggerItem;
			case 3: 
				return SteelBattleAxeItem;
			case 4:
				 return "SPELL sunBurst";
			case 5:
				return "SPELL aegis";
			case 6:
				return regularXPPotionItem;
		}
	}
	
	else if(%luck < 200)
	{
		switch(getRandom(4))
		{
			case 0:
				return mithrilDaggerItem;
			case 1:
				return mithrilShortSwordItem;
			case 2:
				return "SPELL greaterHeal";
			case 3:
				return hugeHPPotionItem;
			case 4:
				return hugeManaPotionItem;
		}
	}
	
	else if(%luck >= 200)
	{
	switch(getRandom(7))
		{
			case 0:
				return mithrilDaggerItem;
			case 1:
				return "SPELL angelicdestiny";
			case 2:
				return mithrilShortSwordItem;
			case 3:
				return mithrilBattleAxeItem;
			case 4:
				return mithrilLongSwordItem;
			case 5:
				return hugeHPPotionItem;
			case 6:
				return hugeManaPotionItem;
			case 7:
				return hugeXPPotionItem;
		}
	}
	
	return 0;
}

function gameConnection::addDXP(%this, %amount)
{
	if(%amount == 0 || %amount $= "")
		return;
		
	%required = %this.level * 100;
	%this.DXP += %amount;
	
	while(%this.DXP > %required)
	{
		%this.centerPrint("<color:cccccc><font:impact:33>Level up!<br><font:verdana:18><color:aa2222>You have ascended to level" SPC %this.level+1 @ ".", 6);
		serverPlay3D(dungeonLevelupSound, %this.player.getPosition());
		
		%this.DXP -= %this.level * 100;
		
		%this.level++;
		
		switch(%this.level)
		{
			case 1:
				%this.player.setDatablock(dungeonPlayerLevelOne);
				
			case 2:
				%this.player.setDatablock(dungeonPlayerLevelTwo);
				
			case 3:
				%this.player.setDatablock(dungeonPlayerLevelThree);

			case 4:
				%this.player.setDatablock(dungeonPlayerLevelFour);
				
			case 5:
				%this.player.setDatablock(dungeonPlayerLevelFive);
				
			case 6:
				%this.player.setDatablock(dungeonPlayerLevelSix);
				
			case 7:
				%this.player.setDatablock(dungeonPlayerLevelSeven);
				
			case 8:
				%this.player.setDatablock(dungeonPlayerLevelEight);
				
			case 9:
				%this.player.setDatablock(dungeonPlayerLevelNine);
				
			case 10:
				%this.player.setDatablock(dungeonPlayerLevelTen);
		}

		%this.maxHealth += 50;
		%this.player.setMaximumHealth(%this.maxHealth);
		%this.player.setShapeName(%this.name SPC "LEVEL" SPC %this.level @ "", 8564862);
		%this.player.maxMana += 25;
		%this.player.mana = %this.player.maxMana;

		%this.player.setHealth(%this.maxHealth);
		
		%required = %this.level * 100;
	}
	
	%this.displayDungeonstathud();

}

function gameConnection::displayDungeonStatHud(%this)
{
	%level = %this.Level;
	%xp = %this.dxp;
	%health = (%this.player.getDataBlock().maxdamage - %this.player.getDamageLevel())* %this.player.damageResistance;
	%health = mFloatLength(%health, 0);
	%gold = %this.gold;

	if(%this.player.magicShields >= 1)
		%effects = %effects SPC "\c7| \c5ARMOR:" SPC mFloatLength(%this.player.magicShields, 0);
	if(%this.player.damageReduction >= 1)
		%effects = %effects SPC "\c7| \c5SHIELDING:" SPC mFloatLength((1 - %this.player.damageReduction) * 100, 0) @ "%";
	if(%this.player.poison >= 1)
		%effects = %effects SPC "\c7| \c2POISON:" SPC mFloatLength(%this.player.poison, 0);
	if(%this.player.isInvincible)
		%effects = %effects SPC "\c7| \c7INVINCIBLE";

	%healthRatio = %health/%this.maxHealth;
	if(%healthRatio < 0.3)
		%healthColor = "\c0";
	else if(%healthRatio < 0.7)
		%healthColor = "\c3";
	else
		%healthColor = "\c2";
	
	%this.score = %this.level;

	//<font:verdana:18>
	%this.bottomPrint("\c7Health:" SPC %healthColor @ %health @ "\c7/" @ %this.maxHealth SPC "Mana:" SPC %this.player.mana @ "/" @ %this.player.maxMana SPC "EXP:" SPC %xp @ "/" @ %level*100 SPC "Level:" SPC %level SPC "\c3Gold\c7:" SPC %gold SPC %effects);
}

function openChest(%client, %pos, %numDrops)
{
	%x = firstWord(%client.player.getPosition());
	%y = getWord(%client.player.getPosition(), 1);
	
	%x = mfloatLength(%x/16,0);
	%y = mFloatLength(%y/16,0);
	
	
	
	%level = $dungeonMaster[%x, %y].level;
	
	for(%i = %numDrops; %i > 0; %i--)
	{
		%itemData = getTieredItem(getRandom(0,25), %level);
		
		if(%itemData $= "")
			continue;
			
		if(firstWord(%itemData) $= "SPELL")
		{
			%client.buySpell(getWord(%itemData, 1));
			continue;
		}
			
		if(!isobject(nameToID(%itemData)))
		{
			continue;
		}
		else
			%itemData = nameToID(%itemData);
		
		%pos = vectorAdd(%pos, "0 0 1");

		%vec = "0 0 0";

		%item = new Item()
		{
			datablock = %itemData;
			position = %pos;
		};
		
		%itemVec = %vec;
		%itemVec = vectorAdd(%itemVec,getRandom(-4,4) SPC getRandom(-4,4) SPC 5);
		%item.BL_ID = 777;
		%item.minigame = $dungeonMinigame;
		%item.spawnBrick = -1;
		%item.setVelocity(%itemVec);
		
		if(!isObject(nameToID(DungeonCleanupGroup)))
			%item.schedulePop();
		
		nameToID(DungeonCleanupGroup).add(%item);
		
		//%item.schedulePop();
	}
	
	makeChange(%pos, getrandom(5, 75*%level));
	
	//%client.addDXP(getRandom(2, 15)*%level);
}

function rotationFromAngleID(%angle)
{
	switch(%angle)
	{
		case 0:
			%rotation = "1 0 0 0";
		case 1:
			%rotation = "0 0 1 90";
		case 2:
			%rotation = "0 0 1 180";
		default:
			%rotation = "0 0 -1 90";
	}
	return %rotation;
}

function serverCmdBuy(%client)
{
	%item = %client.player.lastShopItemSelected;
	if(!isObject(%item))
	{
		%client.chatMessage("Too late, it's gone!");
		return;
	}

	if(isObstruction(%item.getPosition(), %client.player) || vectorDist(%item.getPosition(), %client.player.getPosition()) > 6)
	{
		%client.chatMessage("You're too far away from that item to buy it...");
		return;
	}

	if(%client.gold < %item.price)
	{
		%client.chatMessage("You need more gold to buy that!");
		return;
	}

	%client.player.directAddWeapon(%item.getDatablock());
	%client.gold -= %item.price;

	%item.delete();
}


//COINS

//Copper

datablock itemData(coinCopperItem : printGun)
{
	image = "";
	uiName = "Coin (Copper)";
	shapeFile = "./coin.dts";
	
	doColorShift = true;
	colorShiftColor = 204/255 SPC 102/255 SPC 0/255 SPC 1.000;
	
	goldValue = 1;
};

function coinCopperItem::onAdd(%this, %obj)
{
	%obj.rotate = 1;
}

function coinCopperItem::onPickup(%this, %obj, %col)
{
	ScorePickup(%this, %obj, %col);
}

//Silver

datablock itemData(coinSilverItem : printGun)
{
	image = "";
	uiName = "Coin (Silver)";
	shapeFile = "./coin.dts";
	
	doColorShift = true;
	colorShiftColor = 192/255 SPC 192/255 SPC 192/255 SPC 1.000;
	
	goldValue = 50;
};

function coinSilverItem::onAdd(%this, %obj)
{
	%obj.rotate = 1;
}

function coinSilverItem::onPickup(%this, %obj, %col)
{
	ScorePickup(%this, %obj, %col);
}

//Gold

datablock itemData(coinGoldItem : printGun)
{
	image = "";
	uiName = "Coin (Gold)";
	shapeFile = "./coin.dts";
	
	doColorShift = true;
	colorShiftColor = 255/255 SPC 222/255 SPC 0/255 SPC 1.000;
	
	goldValue = 100;
};

function coinGoldItem::onAdd(%this, %obj)
{
	%obj.rotate = 1;
}

function coinGoldItem::onPickup(%this, %obj, %col)
{
	ScorePickup(%this, %obj, %col);
}

//Coin stack of 5

//Copper Stack

datablock itemData(coinstackCopperItem : printGun)
{
	image = "";
	uiName = "Coin Stack (5 Copper)";
	shapeFile = "./coinstack5.dts";
	
	doColorShift = true;
	colorShiftColor = 204/255 SPC 102/255 SPC 0/255 SPC 1.000;
	
	goldValue = 5;
};

function coinstackCopperItem::onAdd(%this, %obj)
{
	%obj.rotate = 1;
}

function coinstackCopperItem::onPickup(%this, %obj, %col)
{
	ScorePickup(%this, %obj, %col);
}

//Silver Stack

datablock itemData(coinstackSilverItem : printGun)
{
	image = "";
	uiName = "Coin Stack (5 Silver)";
	shapeFile = "./coinstack5.dts";
	
	doColorShift = true;
	colorShiftColor = 192/255 SPC 192/255 SPC 192/255 SPC 1.000;
	
	goldValue = 250;
};

function coinstackSilverItem::onAdd(%this, %obj)
{
	%obj.rotate = 1;
}

function coinstackSilverItem::onPickup(%this, %obj, %col)
{
	ScorePickup(%this, %obj, %col);
}

//Gold Stack

datablock itemData(coinstackGoldItem : printGun)
{
	image = "";
	uiName = "Coin Stack (5 Gold)";
	shapeFile = "./coinstack5.dts";
	
	doColorShift = true;
	colorShiftColor = 255/255 SPC 222/255 SPC 0/255 SPC 1.000;
	
	goldValue = 500;
};

function coinstackGoldItem::onAdd(%this, %obj)
{
	%obj.rotate = 1;
}

function coinstackGoldItem::onPickup(%this, %obj, %col)
{
	ScorePickup(%this, %obj, %col);
}

function ScorePickup(%this, %obj, %col)
{ 	
	if(!%col.getClassName() $= "Player" || %col.isDungeonAI)
		return;

	%col.client.gold += %this.goldValue;
	serverplay3d(scorePickupSound,%col.position);
	%col.client.displayDungeonstathud();
	

	%obj.delete();
}

function player::directAddWeapon(%player, %itemData)
{
	%item = %itemData;
	%client = %player.client;
	%uiName = %itemData.uiName;

	if(!isObject(%client.player) || %itemData $= "")
		return;
	
	if(!isObject(%item)) //item not found
	{
		%client.chatMessage("ERROR: ITEM" SPC %itemData SPC "NOT FOUND. NOTIFY HOST.");
		return;
	}
	
	if(%item.getClassName() !$= "ItemData")
	{
		%client.chatMessage("ERROR:" SPC %itemData SPC "IS NOT AN ITEMDATA DATABLOCK.");
	}

	for(%i = 0; %i < %player.dataBlock.maxTools; %i++)
	{
		// if(%player.tool[%i] == %item)
		// 	return;

		if(!%player.tool[%i])
		{
			%slot = %i;
			break;
		}
	}

	if(%slot $= "") //no tool slots available
	{
		%dropItem = new Item()
		{
			dataBlock = %item;
			position = %player.getHackPosition();
		};

		%dropItem.BL_ID = 777;
		%dropItem.minigame = $dungeonMinigame;
		%dropItem.spawnBrick = -1;

		if(!isObject(dungeonCleanupGroup))
			%dropItem.schedulePop();
		nameToID(dungeonCleanupGroup).add(%dropItem);

		commandToClient(%player.client, 'messageBoxOK', "Notification", "You didn't have enough room in your inventory for that item! It's now on the ground.");
		return;
	}

	%player.tool[%slot] = %item;
	messageClient(%client, 'MsgItemPickup', "", %slot, %item);
}

function player::addWeapon(%player, %uiName, %client)
{
	%client = %player.client;

	if(!isObject(%client.player) || %uiName $= "")
		return;

	for(%i = 0; %i < DataBlockGroup.getCount(); %i++)
	{
		%obj = DataBlockGroup.getObject(%i);

		if(%obj.getClassName() $= "ItemData" && strStr(strlwr(%obj.uiName), strlwr(%uiName)) != -1)
		{
			%item = %obj;
			break;
		}
	}

	if(!isObject(%item)) //item not found
	{
		%client.chatMessage("ERROR: ITEM" SPC %uiName SPC "NOT FOUND. NOTIFY HOST.");
		return;
	}

	for(%i = 0; %i < %player.dataBlock.maxTools; %i++)
	{
		// if(%player.tool[%i] == %item)
		// 	return;

		if(!%player.tool[%i])
		{
			%slot = %i;
			break;
		}
	}

	if(%slot $= "") //no tool slots available
	{
		%dropItem = new Item()
		{
			dataBlock = %item;
			position = %player.getHackPosition();
		};

		%dropItem.BL_ID = 777;
		%dropItem.minigame = $dungeonMinigame;
		%dropItem.spawnBrick = -1;

		if(!isObject(dungeonCleanupGroup))
			%dropItem.schedulePop();
		nameToID(dungeonCleanupGroup).add(%dropItem);

		commandToClient(%player.client, 'messageBoxOK', "Notification", "You didn't have enough room in your inventory for that item! It's now on the ground.");
		return;
	}

	%player.tool[%slot] = %item;
	messageClient(%client, 'MsgItemPickup', "", %slot, %item);
}

function makeChange(%pos, %amount)
{
	while(%amount > 0)
	{	
		if(%amount >= 500)
		{
			%amount -= 500;
			%itemData = coinstackGoldItem;
		}
		
		else if(%amount >= 250)
		{
			%amount -= 250;
			%itemData = coinstackSilverItem;
		}
		
		else if(%amount >= 100)
		{
			%amount -= 100;
			%itemData = coinGoldItem;
		}
		
		else if(%amount >= 50)
		{
			%amount -= 50;
			%itemData = coinSilverItem;
		}
		
		else if(%amount >= 5)
		{
			%amount -= 5;
			%itemData = coinstackCopperItem;
		}
		
		else if(%amount >= 1)
		{
			%amount -= 1;
			%itemData = coinCopperItem;
		}
		else
			break;
		
		
		
		%itemData = nameToID(%itemData);
		
		%pos = vectorAdd(%pos, "0 0 1");

		%vec = "0 0 0";

		%item = new Item()
		{
			datablock = %itemData;
			position = vectorAdd(%pos, getRandom(10,-10)/10 SPC getRandom(10,-10)/10 SPC "0");
		};
		
		%itemVec = %vec;
		%itemVec = vectorAdd(%itemVec,getRandom(-30,30)/10 SPC getRandom(-30,30)/10 SPC 2);
		%item.BL_ID = 777;
		%item.minigame = $dungeonMinigame;
		%item.spawnBrick = -1;
		%item.setVelocity(%itemVec);
		
		nameToID(DungeonCleanupGroup).add(%item);
		//%item.schedulePop();
	}
}

function dungeonTimerLoop()
{
	if(isObject($dungeonLoopSchedule))
		cancel($dungeonLoopSchedule);

	if(!isObject($dungeonMinigame))
		return;

	if($sim::Time > $dungeonStartTime + 1800)
	{
		announce("Time's up! Dungeon is resetting. This might lag for a minute, so hold onto your pants.");
		schedule(1000, 0, startDungeon, $dungeonMinigame);
		return;
	}
	else
	{
		%time = mFloatLength(($dungeonStartTime + 1800 - $sim::time)/60, 0);
		announce("There are" SPC %time SPC "minutes remaining in the dungeon.");
	}

	$dungeonLoopSchedule = schedule(120000, 0, dungeonTimerLoop);
}

function gameConnection::calculateKarma(%this, %kill)
{
	$karmaLevel[%this.bl_id] = %this.karma;
	
	if(%kill && %this.karma > -150)
	{
		%this.karma = -150;
	}
	
	
	if(%this.karma > -30 && %this.karmaStatus > 0)
	{
		%this.chatMessage("<color:ffffff>Your status is now normal.");
		%this.player.setShapeNameColor("0 0 0");
		%this.karmaStatus = 0;
		%this.player.unMountImage(1);
	}
	else if(%this.karma > -150 && %this.karmaStatus > 1)
	{
		%this.chatMessage("<color:ff2200>Your status is now orange.");
		%this.player.setShapeNameColor("1 0.5 0");
		%this.karmaStatus = 1;
		%this.player.unmountimage(1);
	}
	else if(%this.karma <= -30 && %this.karmaStatus < 1)
	{
		%this.chatMessage("<color:ff2200>Your status is now orange. Players will know that you attacked someone.");
		%this.player.setShapeNameColor("1 0.5 0");
		%this.karmaStatus = 1;
	}
	
	else if(%this.karma <= -150 && %this.karmaStatus < 2)
	{
		%this.chatMessage("<color:ff0000>You are now marked as a player killer.");
		%this.player.setShapeNameColor("1 0 0");
		%this.karmaStatus = 2;
		%this.player.mountimage(pvpSkullImage, 1);
	}
	
	else if(%this.karma < -2000)
	{
		banBLID(%this.BL_ID, 1200, "The gods smite you.");
	}
}

function servercmdAcceptContract(%client)
{
	if(!isObstruction(%client.player.demonBookLoc, %client.player) && !%client.player.demonContract)
	{
		%client.maxHealth -= 200;
		%client.player.setMaximumHealth(%client.maxHealth);

		if(%client.maxHealth <= 0)
		{
			%client.player.kill();
			commandToClient(%client, 'messageBoxOK', "", "You couldn't pay that sacrifice. I took your soul instead.");
			return;
		}

		%client.player.addWeapon("Gram");
		serverPlay3D(dungeonContractSound, %client.player.getPosition());
		commandToClient(%client, 'messageBoxOK', "", "Behold, the Demonic Sword Gram. A personal favorite of mine.");
		%client.player.demonContract = 1;
	}
}

function player::setPoison(%this, %amount)
{
	%this.poison = %amount;
}

function player::dropItem(%this, %slot)
{
	%itemData = %this.tool[%slot];

	if(!isObject(%itemData))
	{
		error("No tool in that slot!");
		return 0;
	}

	%this.tool[%slot] = "";
}

function player::throwItem(%this, %itemData)
{
	if(!isObject(%itemData))
	{
		error("Invalid item datablock.");
		return 0;
	}

	%item = new Item()
	{
		datablock = %itemData;
		position = %this.getHackPosition();
	};

	%item.minigame = %this.minigame;
	%item.BL_ID = %this.client.BL_ID;

	%item.setVelocity(%this.getEyeVector());
}

function serverCmdContinueTutorial(%client)
{
	switch(%client.tutorialPosition)
	{
		case 0:
			%head = "Tutorial";
			%text = "Welcome to Dungeon Generator!<br><br>Would you like a quick tutorial on how to play?<br><br>(Press YES on all additional prompts to continue through the tutorial)";

		case 1:
			%head = "Tutorial - Basics";
			%text = "The Dungeon Generator is a single gigantic dungeon where everyone is competing (or working together) to find the end of the dungeon.";

		case 2:
			%head = "Tutorial - Basics";
			%text = "As you advance closer to the end of the dungeon, you will discover new types of areas and monsters to fight! This game is PERMADEATH; when you die, you have to start all over again!<br>(Try not to die)";

		case 3:
			%head = "Tutorial - Basics";
			%text = "In general, if you're trying to advance to the next area you should try to pick a direction and make sure you keep traveling in that direction. Going in circles will get you nowhere.";

		case 4:
			%head = "Tutorial - Magic";
			%text = "While exploring, you may find some spells! To cast a spell, say /cast <spellname> in the chat.";

		case 5:
			%head = "Tutorial - Magic";
			%text = "You may also find a magic staff along the way, these are useful for casting spells more quickly. To set a spell to the staff, you'll need to do /setautocast <spellname>";

		case 6:
			%head = "Tutorial - Magic";
			%text = "You can do /listspells at any time to check what spells you know. Spells are the only thing you don't lose when you die.";

		case 7:
			%head = "Tutorial - Shops";
			%text = "While exploring, you might find a shop! These are where you'll be able to spend your gold- mostly on potions.";

		case 8:
			%head = "Tutorial - PvP";
			%text = "While exploring, you might run into other players. You can either team up, ignore each other, or one of you may decide to attack the other!";

		case 9:
			%head = "Tutorial - PvP";
			%text = "Attacking players will make you lose karma, which has bad side effects. If you need to defend yourself from another player, wait until a message shows up warning you about being attacked before fighting back. You won't lose karma for defending yourself.";

		case 10:
			%head = "Tutorial - Misc";
			%text = "The grassy plains may be easy, but the game ramps up in difficulty quickly once you leave there. Make sure you're prepared to move on!";

		case 11:
			commandToClient(%client, 'messageBoxOK', "Tutorial - End", "This is the end of the tutorial. Good luck!<br><br>Do /tutorial if you wish to view it again.");
			%client.tutorialComplete = true;
			return;
	}

		commandToClient(%client, 'messageBoxYesNo', %head, %text, 'continueTutorial');
		%client.tutorialPosition++;
}

function serverCMDtutorial(%client)
{
	%client.tutorialPosition = 0;
	serverCmdContinueTutorial(%client);
}

function serverCmdHelp(%client)
{
	commandToClient(%client, 'messageBoxOK', "Quick magic reference", "/listspells<br>/cast<br>/setautocast");
}

package clickyDungeon
{
	function Player::Activatestuff(%obj)
	{
		Parent::Activatestuff(%obj);
		
		%ray = containerRaycast(%obj.getEyePoint(),vectorAdd(%obj.getEyePoint(),vectorScale(%obj.getEyeVector(),3)),$Typemasks::fxBrickObjectType | $TypeMasks::ItemObjectType,%obj);
		if(isObject(%col=firstWord(%ray)))
		{
			if(%col.dungeonDoor)
				%col.openDungeonDoor(%col.dungeonDoor, %obj.client);
			else if(%col.isShopBrick)
				%obj.client.openShop(%obj.getHackPosition());
				
			else if(%col.getDatablock().getName() $= "BrickSingleChestData")
			{
				if(%obj.client.karmaStatus >= 2)
				{
					commandToClient(%obj.client, 'messageBoxOK', "", "The chest remains sealed!");
					return;
				}
				%col.setDatablock("BrickSingleChestOpenData");
				
				openChest(%obj.client, %col.getPosition(), getRandom(1,3));
			}
			
			else if(%col.pedestalType)
			{
				if(%obj.client.karmaStatus >= 2)
				{
					commandToClient(%obj.client, 'messageBoxOK', "", "Repent your sins, wicked one!");
					return;
				}
				%col.setEmitter(FridgeFog1Emitter);
				%col.schedule(300, setDatablock, brick2x2x3CrystalPedestalBData);
				serverPlay3D(dungeonChargeSound, %obj.getPosition());
				
				
				switch(%col.pedestalType)
				{
					case 1:
						%obj.maxMana += 50;
						%obj.Mana += 50;
						%obj.client.maxHealth += 25;
						%obj.setMaximumHealth(%obj.client.maxHealth);
						%obj.client.centerPrint("<color:3333ee><font:verdana:25>You feel suddenly imbued with power!<br><color:ffffff>+50 Max Mana<br>+25 Max HP", 5);
						
					case 2:
						%obj.maxMana += 100;
						%obj.Mana += 100;
						%obj.client.centerPrint("<color:3333ee><font:verdana:25>You feel suddenly imbued with power!<br><color:ffffff>+100 Max Mana", 5);
						
					case 3:
						%obj.client.maxHealth += 50;
						%obj.setMaximumHealth(%obj.client.maxHealth);
						%obj.client.centerPrint("<color:3333ee><font:verdana:25>You feel suddenly imbued with power!<br><color:ffffff>+50 Max HP", 5);
				}
				
				%col.pedestalType = 0;
			}
			else if(%col.getType() & $typeMasks::ItemObjectType)
			{
				%col.getDatablock().onPickup(%col, %obj);
			}

			else if(%col.demonBookBrick)
			{
				if(!%obj.demonContract)
				{
					commandToClient(%obj.client, 'messageBoxYesNo', "", "Do you wish to make a contract?<br><br>Required sacrifices:<br>200 HP<br>YOUR SOUL (To be collected later)", 'acceptContract');
					%obj.demonBookLoc = vectorAdd(%col.getPosition(), "0 0 4");
					return;
				}
				else
				{
					%obj.client.centerPrint("You've already sold your soul!", 3);
					return;
				}
			}
		}
	}
	
	
	function gameConnection::spawnPlayer(%this)
	{
		parent::spawnPlayer(%this);
		
		if(isObject(%this.minigame))
		{			
			%this.gold = 0;
			%this.dxp = 0;
			%this.level = 1;
			%this.player.mana = 50;
			%this.player.isusingMana = 1;
			%this.player.maxMana = 50;
			%this.displayDungeonstathud();
			%this.player.setDatablock(dungeonPlayerLevelOne);
			%this.player.schedule(100, manaLoop);
			%this.player.createSpawnArea(0);
			%this.player.setMaximumHealth(100);
			%this.player.setShapeName(%this.name SPC " LEVEL" SPC %this.level, 8564862);
			%this.maxHealth = 100;
		}
		%this.karmaStatus = 0;
		%this.karma = $karmaLevel[%this.BL_ID];
		
		if(%this.karma < -150)
		{
			%this.player.setShapeNameColor("1 0 0");
			%this.player.mountimage(pvpSkullImage, 1);
			%this.karmaStatus = 2;
		}
		
		else if (%this.karma < -30)
		{
			%this.player.setShapeNameColor("1 0.5 0");
			%this.karmaStatus = 1;
		}
		else if (%this.karma < -2000)
			banBLID(%this.BL_ID, 1200, "The gods smite you.");

		if(%this.tutorialPosition $= "")
		{
			%this.tutorialPosition = 0;
			schedule(5000, %this, serverCmdContinueTutorial, %this);
		}
	}
	
	function ProjectileData::damage(%this,%obj,%col,%fade,%pos,%normal)
	{
		%scale = getWord(%obj.getScale(), 2);

		if(%col.damageResistance == 0)
			%col.damageResistance = 1;

	    %predictedDamage = (mClampF(%this.directDamage, -100, 100) * %scale)/%col.damageResistance;
		
		if(%col.getClassname() $= Player && %obj.sourceObject.getClassname() $= Player)
		{
			if(%col.client.karmaStatus > 0)
			{
				doNothing();
			}
			else
			{
				%obj.sourceObject.client.karma -= %predictedDamage;
				%obj.sourceObject.client.centerPrint("Don't attack allies!",3); //<br>-" @ %predictedDamage*(0.5*%obj.sourceObject.client.level) SPC "karma!
				%obj.sourceObject.client.calculateKarma(0);
				if(%col.getDatablock().maxDamage <= %col.getDamageLevel() + %predictedDamage)
				{
					%obj.sourceObject.client.calculateKarma(1);
				}
				else if(%obj.sourceObject.client.karmaStatus > 0)
				{
					%col.client.centerPrint("Another player is attacking you! Fight back or flee!", 4);
				}
			}
		}
	
		if(%col.getDatablock().maxDamage <= %col.getDamageLevel() + %predictedDamage)
		{
			%obj.sourceObject.client.addDXP(%col.client.level*getRandom(3,15));
			
			if(getRandom(0,4) == 4 && %obj.sourceObject.getClassName() !$= "AIPlayer")
			{
				openChest(%obj.sourceObject.client, %pos, getRandom(1));
				%obj.sourceObject.client.addDXP(getRandom(2, 15)*%level);
			}
			
			if(%col.getClassName() $= "Player")
			{
				%col.client.karma /= %col.client.level;
				%col.client.calculateKarma();
			}
		}
		else if(%col.client.getClassName() $= "GameConnection")
			%col.client.displayDungeonstathud();

		if(%col.AiMode $= scorpionBoss)
		{
			if(%col.lastRetreatTime < $sim::time + 3)
			{
				dungeonBotThinkRetreatScorpionBoss(%col);
				%col.lastRetreatTime = $sim::time;
			}
			
		}
		
	   parent::damage(%this,%obj,%col,%fade,%pos,%normal);
	}

	function armor::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{
		parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		
		if(!isObject(%col) || !isObject(%obj))
			return;

		if(%col.getType() & $typeMasks::ItemObjectType && %obj.client.BL_ID && !%obj.isDungeonAI)
		{
			%col.getDatablock().onPickup(%col, %obj);
		}

		if(%obj.AiMode !$= "" && isObject(%col))
		{
			if(%col.getClassName() $= "Player" && %obj.getState() !$= "dead")
			{
				if(%obj.AiMode $= "scorpionBoss" && %obj.lastAttackTime < $sim::time - 0.5)
				{
					if(%obj.stingReady)
					{
						%obj.playThread(4, sting);
						%col.setPoison(10);
						%obj.schedule(150, playThread, 4, root);
					}

					%obj.playThread(2, activate);
					%col.damage(0, %pos, %obj.attackDamage, $damageType::Default);
					%col.setVelocity(vectorScale(%obj.getEyeVector(), 12));
					%obj.schedule(300, playThread, 2, root);
					%obj.lastAttackTime = $sim::time;
				}

				else if(%obj.lastAttackTime < $sim::time - 0.5)
				{
					%col.damage(0, %pos, %obj.attackDamage, $damageType::Default);
					%col.setVelocity(vectorScale(%obj.getEyeVector(), 6));
					%obj.playThread(2, activate);
					%obj.schedule(300, playThread, 2, root);
					%obj.lastAttackTime = $sim::time;

					if(%obj.AiMode $= "flyingBite")
					{
						cancel(%obj.thinkSchedule);
						dungeonBotThinkRetreatFB(%obj);
					}
				}
			}
		}
	}
	
	
	function serverCMDCast(%client, %spell, %animation)
	{
		parent::serverCMDCast(%client, %spell, %animation);
		
		%client.schedule(100, displayDungeonStatHud);
	}
	
	function player::manaLoop(%this)
	{
		parent::manaLoop(%this);
		if(%this.poison > 0)
		{
			%this.damage(0, %this.getPosition(), %this.poison, $damageType::Default);
			%this.poison--;
		}
		%this.client.displayDungeonStatHud();
	}
	
	function player::addHealth(%this, %health)
	{
		parent::addHealth(%this,%health);
		%this.client.displayDungeonStatHud();
	}
	
	
	function armor::onDisabled(%this, %obj, %enabled)
	{
		if(%obj.client.gold)
			makeChange(%obj.getPosition(), %obj.client.gold);

		return parent::onDisabled(%this, %obj, %enabled);
	}
	
	function aiPlayer::onDeath(%this)
	{
		%this.setImageTrigger(0, 0);
		cancel(%this.thinkSchedule);
		return;
	}
	
	function aiPlayer::getTeam(%this)
	{
		return 0;
	}

	function itemData::onPickup(%this, %obj, %col)
	{
		if(%col.isDungeonAI)
			return;

		if(%obj.isShopItem)
		{
			%col.client.centerPrint("Item:" SPC %obj.itemName SPC "Price:" SPC %obj.price @ "<br>Do /buy to purchase this item from the shop!", 5);
			%col.lastShopItemSelected = %obj;
			return;
		}
		else
			parent::onPickup(%this, %obj, %col);
	}
};

activatepackage(clickydungeon);

function isObstruction(%pos,%player)
{
   %object = ContainerRayCast(%pos,%player.getEyePoint(), $TypeMasks::FxBrickObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::VehicleObjectType, %player);

   %obstr = getWord(%object,0);
   if(isObject(%obstr) && %obstr.getDatablock().getName() !$= "brick4x1x5windowData")
      return 1;
   else
      return 0;
}

announce("Loaded successfully!");


// External Packages!

package InventorySlotAdjustment
{
	function Armor::onNewDatablock(%data,%this)
	{
		Parent::onNewDatablock(%data,%this);
		if(isObject(%this.client) && %data.maxTools != %this.client.lastMaxTools)
		{
			%this.client.lastMaxTools = %data.maxTools;
			commandToClient(%this.client,'PlayGui_CreateToolHud',%data.maxTools);
			for(%i=0;%i<%data.maxTools;%i++)
			{
				if(isObject(%this.tool[%i]))
					messageClient(%this.client,'MsgItemPickup',"",%i,%this.tool[%i].getID(),1);
				else
					messageClient(%this.client,'MsgItemPickup',"",%i,0,1);
			}
		}
	}
	function GameConnection::setControlObject(%this,%obj)
	{
		Parent::setControlObject(%this,%obj);
		if(%obj == %this.player && %obj.getDatablock().maxTools != %this.lastMaxTools)
		{
			%this.lastMaxTools = %obj.getDatablock().maxTools;
			commandToClient(%this,'PlayGui_CreateToolHud',%obj.getDatablock().maxTools);
		}
	}
	function Player::changeDatablock(%this,%data,%client)
	{
		if(%data != %this.getDatablock() && %data.maxTools != %this.client.lastMaxTools)
		{
			%this.client.lastMaxTools = %data.maxTools;
			commandToClient(%this.client,'PlayGui_CreateToolHud',%data.maxTools);
		}
		Parent::changeDatablock(%this,%data,%client);
	}
};
activatePackage(InventorySlotAdjustment);

package Server_DropInventoryOnDeath
{
	function gameConnection::onDeath(%client,%source,%killer,%type,%location)
	{
		if(isObject(%client.minigame))
		{
			if(isObject(%client.player))
			{
				for(%i=0;%i<%client.player.getDatablock().maxTools;%i++)
				{
					%item = %client.player.tool[%i];
					if(isObject(%item))
					{
						%pos = %client.player.getPosition();
						%posX = getWord(%pos,0);
						%posY = getWord(%pos,1);
						%posZ = getWord(%pos,2);
						%vec = %client.player.getVelocity();
						%vecX = getWord(%vec,0);
						%vecY = getWord(%vec,1);
						%vecZ = getWord(%vec,2);
						%item = new Item()
						{
							dataBlock = %item;
							position = %pos;
						};
						%itemVec = %vec;
						%itemVec = vectorAdd(%itemVec,getRandom(-8,8) SPC getRandom(-8,8) SPC 10);
						%item.BL_ID = 777;
						%item.minigame = $dungeonMinigame;
						%item.spawnBrick = -1;
						%item.setVelocity(%itemVec);
						//%item.schedulePop();
						if(!isObject(dungeonCleanupGroup))
							%item.schedulePop();
						nameToID(dungeonCleanupGroup).add(%item);
					}
					%client.player.tool[%i] = "";
			
				}
			}
		}
		return Parent::onDeath(%client,%source,%killer,%type,%location);
	}
};
activatePackage(Server_DropInventoryOnDeath);

package DamageResistance
{
	function Player::applyDamage(%this, %value)
	{
		if(%this.DamageResistance > 0)
			%value /= %this.DamageResistance;
		Parent::applyDamage(%this, %value);
	}
	
	function Player::applyRepair(%this, %value) //Can't think of where this function is used, but may as well get it.
	{
		if(%this.DamageResistance > 0)
			%value /= %this.DamageResistance;
		Parent::applyRepair(%this, %value);
	}
	
	function Player::addHealth(%this, %value)
	{
		if(%this.DamageResistance > 0 && %value > 0) //Apparently negative values are run through the damage function instead, so we don't want our effect applied twice.
			%value /= %this.DamageResistance;
		Parent::addHealth(%this, %value);
	}
	
	//Intentionally leaving out the set health values for now.
	
	function Player::setDatablock(%this, %db) //Make sure the value is applied when we change datablocks.
	{
		%this.DamageResistance *= %this.getDatablock().maxDamage;
		Parent::setDatablock(%this, %db);
		%this.DamageResistance /= %this.getDatablock().maxDamage;
	}

	function AiPlayer::applyDamage(%this, %value)
	{
		if(%this.DamageResistance > 0)
			%value /= %this.DamageResistance;
		Parent::applyDamage(%this, %value);
	}
	
	function AiPlayer::applyRepair(%this, %value) //Can't think of where this function is used, but may as well get it.
	{
		if(%this.DamageResistance > 0)
			%value /= %this.DamageResistance;
		Parent::applyRepair(%this, %value);
	}
	
	function AiPlayer::addHealth(%this, %value)
	{
		if(%this.DamageResistance > 0 && %value > 0) //Apparently negative values are run through the damage function instead, so we don't want our effect applied twice.
			%value /= %this.DamageResistance;
		Parent::addHealth(%this, %value);
	}
	
	//Intentionally leaving out the set health values for now.
	
	function AiPlayer::setDatablock(%this, %db) //Make sure the value is applied when we change datablocks.
	{
		%this.DamageResistance *= %this.getDatablock().maxDamage;
		Parent::setDatablock(%this, %db);
		%this.DamageResistance /= %this.getDatablock().maxDamage;
	}
};
activatePackage(DamageResistance);

function Player::SetMaximumHealth(%this, %value)
{
	if(%value <= 0)
	{
		%this.DamageResistance = 0;
		return;
	}
	%baseHealth = %this.getDatablock().maxDamage;
	%this.DamageResistance = %value / %baseHealth;
}

function AiPlayer::SetMaximumHealth(%this, %value)
{
	if(%value <= 0)
	{
		%this.DamageResistance = 0;
		return;
	}
	%baseHealth = %this.getDatablock().maxDamage;
	%this.DamageResistance = %value / %baseHealth;
}

$gc = 9.84;
function calculateThrownVector(%pos, %target, %vz, %gm)
{
	%g = $gc * %gm;

	%xi = getWord(%pos, 0);
	%yi = getWord(%pos, 1);
	%zi = getWord(%pos, 2);
	%xf = getWord(%target, 0);
	%yf = getWord(%target, 1);
	%zf = getWord(%target, 2);
	
	%solution = mSolveQuadratic(-0.5 * %g, %vz, %zi - %zf);
	%t = -(getMin(getWord(%solution, 1), getWord(%solution, 2)));
	
	%vx = (%xf - %xi) / %t;
	%vy = (%yf - %yi) / %t;
	
	%vector = %vx SPC %vy SPC %vz;
	return %vector;
}